<?php
namespace Teknisa\CTB\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CTB\Services\Ctb22000RelatorioRazaoOficialServices;

class  Ctb22000RelatorioRazaoOficialController extends \Zeedhi\Framework\Controller\Report{

    protected $reportService;
    protected $dataSourceManager;
    protected $nrorg;
    protected $execRazaoOficial;

    public function __construct(ReportService $reportService, $dataSourceManager, $environment, Ctb22000RelatorioRazaoOficialServices $execRazaoOficial, $birtStrategy) {
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->nrorg = $environment->getNrorgTrab();
        $this->Ctb22000RelatorioRazaoOficialServices = $execRazaoOficial;
        $this->birtStrategy = $birtStrategy;
    }
    
    protected $reportMapping = array (
            'CTB22000' => 
             array(
                 'strategy'=> 'BIRT',
                 'parameterMapping' =>
                 array(
                     'NRRAZAO' => 'NRRAZAO',
                     'DTINICIAL' => 'DTINICIAL',
                     'DTFINAL' => 'DTFINAL',
                     'NRORG' => 'NRORG'
                     )
                 
                 ),
                 
            'CTB22000_SAPORE' => 
             array(
                 'strategy'=> 'BIRT',
                 'parameterMapping' =>
                 array(
                     'NRRAZAO' => 'NRRAZAO',
                     'DTINICIAL' => 'DTINICIAL',
                     'DTFINAL' => 'DTFINAL',
                     'NRORG' => 'NRORG'
                     )
                 
                 ),
                 
            'CTB22000XLSX' => 
             array(
                 'strategy'=> 'BIRT',
                 'parameterMapping' =>
                 array(
                     'NRRAZAO' => 'NRRAZAO',
                     'DTINICIAL' => 'DTINICIAL',
                     'DTFINAL' => 'DTFINAL',
                     'NRORG' => 'NRORG'
                     )
                 
                 ),
                 
            'CTB22000_SAPOREXLSX' => 
             array(
                 'strategy'=> 'BIRT',
                 'parameterMapping' =>
                 array(
                     'NRRAZAO' => 'NRRAZAO',
                     'DTINICIAL' => 'DTINICIAL',
                     'DTFINAL' => 'DTFINAL',
                     'NRORG' => 'NRORG'
                     )
                 
                 )
        );
        
    public function executaProcedureRazaoOficial(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $retornoProcedure = $this->Ctb22000RelatorioRazaoOficialServices->executaProcedureRazaoOficial($row);
            $response->addDataSet(new DataSet('Razao', ['P_NRRAZAO' => $retornoProcedure]));
        }catch(\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function generateReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $reportName = $row["__report_name"];
        $parametersRow = array (
            "NRRAZAO" => $row["NRRAZAO"],
            "DTINICIAL" => $row["DTINICIAL"] ,
            "DTFINAL" =>  $row["DTFINAL"],
            "NRORG" =>  $this->nrorg,
            "__format" => $row["__FORMAT"]
        );
        
        $a = $this->birtStrategy->setReportFormat(strtolower($row["__FORMAT"]));
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        $response->addMessage(new DTO\Response\Message($birtURL));
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
		$row = $request->getRow();

		$row['NRORG'] =  $this->nrorg;
	    $this->birtStrategy->setReportFormat($row["__FORMAT"]);

	}
	
	public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $urlReport) 
    {
        //implementações necessárias pós relatório
        $this->urlReport = $urlReport;
        return $this->urlReport;
    }


}