<?php

namespace Teknisa\CTB\Controllers;


use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Request\Row as Row;
use Teknisa\Libs\Service\CRUD as CrudService;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Teknisa\CTB\Services\ctb00003conciliacaofornecedoresxclientesService;

/*
 * Class conciliacaofornecedoresxclientesController
 * @package Teknisa\CTB\Controllers
*/
 
class ctb00003conciliacaofornecedoresxclientesController {
  protected $environment;
  protected $entityManager;
  protected $ctb00003conciliacaofornecedoresxclientesService;
  
  const NOVOCODIGO_CONCILIACAO = 'NRCTBTEMP';
  const DESCONCILIAR = 0;
  const CONCILIAR = 1;
  const MANUAL = 'M';
  
  /*
  * @param CrudService            $crudService
  * @param ParameterBag           $parameterBag
  * @param Environment            $environment
  * @param conciliacaofornecedoresxclientesService $ctb00003conciliacaofornecedoresxclientesService
  */
   
  public function __construct( $environment, $entityManager, $ctb00003conciliacaofornecedoresxclientesService){
        $this->environment  = $environment;
        $this->entityManager  = $entityManager;
        $this->service = $ctb00003conciliacaofornecedoresxclientesService;
    }
    
  public function executaProcedureGERA_RAZAO_PROV($row, $response) {
    try{
      // Timeout Ilimitado
      set_time_limit(0);
      
      $row  = $row->getRow();
      $nrctbtemp = $this->service->executaprocedure($row, $response);
      $response->addDataSet(new DataSet('gera_razao_prov', ['gera_razao_prov' => $nrctbtemp]));
      
    } catch (\Exception $e){
      $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
    }
  }
  
  public function conciliar($row, $response) {
    try{
      $nrorg = $this->environment->getNrOrgTrab();
      $row  = $row->getRow();
      
    
      foreach($row[0] as $cliente){
        
        $idpart = $cliente['IDPART'];
        $nrctbtemp = $cliente['NRCTBTEMP'];
        $documento = $cliente['CDDOCUCONTT'];
           $this->service->insereConciliacao($nrorg, $nrctbtemp, $idpart, $documento);
          
      }
      
      foreach($row[1] as $fornecedor){

        $idpart = $fornecedor['IDPART'];
        $nrctbtemp = $fornecedor['NRCTBTEMP'];
        $documento = $fornecedor['CDDOCUCONTT'];
           $this->service->insereConciliacao($nrorg, $nrctbtemp, $idpart, $documento);
    
      }
      
      
        //var_dump($row);die;
    } catch (\Exception $e){
      $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
    }
  }
  
  public function desconciliar($row, $response) {
    try{
      $nrorg = $this->environment->getNrOrgTrab();
      $row  = $row->getRow();
      
      foreach($row[0] as $cliente){
        
        $idpart = $cliente['IDPART'];
        $nrctbtemp = $cliente['NRCTBTEMP'];
        $documento = $cliente['CDDOCUCONTT'];
        
        $this->service->updatedesconciliacao($nrorg, $nrctbtemp, $idpart, $documento);
      
      }
      
      foreach($row[1] as $fornecedor){

        $idpart = $fornecedor['IDPART'];
        $nrctbtemp = $fornecedor['NRCTBTEMP'];
        $documento = $fornecedor['CDDOCUCONTT'];
          
        $this->service->updatedesconciliacao($nrorg, $nrctbtemp, $idpart, $documento);
        
      }
      
      
        //var_dump($row);die;
    } catch (\Exception $e){
      $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
    }
  }
  
  
  
}