<?php

namespace Teknisa\CTB\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
//use Teknisa\CTB\Factories\Ctb10000LancamentosContabeisFactory;
//use Teknisa\Libs\Util\DateUtil;
//use Teknisa\Libs\Util\Environment;
//use Teknisa\Libs\Util\NewCode;

const tableName = 'LANCLOTE'; //Tabela no qual será inserida a contabilização de estoque

class ContabilizacaoRetiradaFactory {

    protected $entityManager;
    protected $connection;
    
    private $sql_adqContOpeCtbl            = "SELECT C.IDUTCUSTESTCONT, F.CDFILIAL, C.IDCONSDTMOVIRETEST FROM CONTOPECTBL C, FILIAL F WHERE C.CDEMPRESA = F.CDEMPRESA AND INSTR(:P_CDFILIAL, F.CDFILIAL) <> 0 AND C.CDEMPRESA = :P_CDEMPRESA AND C.NRORG = :P_NRORG AND C.NRORG = F.NRORG";
    private $sql_adqGeraLote               = "SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, TO_DATE(:P_DTCONTAB, 'DD/MM/YY') AS DTCONTAB, SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, DECODE(C.IDRETESTSETOR, 'S', NVL(S.CDCENTCUST, F.CDCENTCUST), F.CDCENTCUST) AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM PRODUTO PR, LOCALESTOQUE LE, HISTPADR HP, CONTOPECTBL C, LANCTOESTOQ L, FILIAL F, PRODFILI PF, RETIRADAESTO R LEFT JOIN SETOR S ON R.CDSETOR = S.CDSETOR AND S.NRORG = :P_NRORG, ITLANCTOEST IT LEFT JOIN PARAMAN PM ON PM.CDFILIAL = IT.CDFILIMOVI AND PM.CDTIPORETI <> IT.CDTIPORETI AND PM.NRORG = :P_NRORG LEFT JOIN TIPORETI TR ON IT.CDTIPORETI = TR.CDTIPORETI AND TR.NRORG = :P_NRORG LEFT JOIN ITREQUESTO IR ON IT.CDFILIAL = IR.CDFILILANC AND IT.NRLANCESTQ = IR.NRLANCESTQ AND IT.NRSEQUITEM = IR.NRSEQUITEM AND IT.CDPRODMOVI = IR.CDPRODUTO AND IR.NRORG = :P_NRORG WHERE(PR.NRORG = :P_NRORG) AND (LE.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (C.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (PF.NRORG = :P_NRORG) AND (PR.CDPRODUTO = IT.CDPRODMOVI) AND (it.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (IT.IDTIPOMOVI = '3' ) AND (IT.CDFILIMOVI = :P_CDFILIAL) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (IT.CDFILIMOVI = LE.CDFILIAL ) AND (IT.CDALMOXARIFE = LE.CDALMOXARIFE) AND (IT.CDLOCALESTOQ = LE.CDLOCALESTOQ) AND (L.CDFILIAL = R.CDFILIALLAN) AND (IT.CDFILIMOVI = LE.CDFILIAL ) AND (IT.CDALMOXARIFE = LE.CDALMOXARIFE) AND (IT.CDLOCALESTOQ = LE.CDLOCALESTOQ) AND (L.NRLANCESTQ = R.NRLANCESTQ ) AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S' ) AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (IT.CDFILIMOVI = F.CDFILIAL) AND (PF.CDFILIAL = IT.CDFILIMOVI) AND (PF.CDPRODUTO = IT.CDPRODMOVI) AND (PF.IDCNTRESTOQ = 'S') AND (F.CDEMPRESA = C.CDEMPRESA) AND (NOT EXISTS (SELECT 1 FROM ORDPRODUCAO OP WHERE R.NRORDPROD = OP.NRORDPROD AND R.NRSUBORDPROD = OP.NRSUBORDPROD AND R.CDFILIAL = OP.CDFILIAL)) GROUP BY IT.CDFILIMOVI , TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, IT.IDTIPOMOVI, DECODE(C.IDRETESTSETOR, 'S', NVL(S.CDCENTCUST, F.CDCENTCUST), F.CDCENTCUST) , CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) , PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV UNION ALL SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, TO_DATE(:P_DTCONTAB, 'DD/MM/YY') AS DTCONTAB, SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, F.CDCENTCUST CDCENTCUSTDB, IT.IDTIPOMOVI AS IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM RETIRADA RE, ITLANCTOEST IT, LANCTOESTOQ L, FILIAL F, PRODUTO PR, TIPORETI TR, HISTPADR HP, PRODFILI PF WHERE (RE.NRORG = :P_NRORG) AND (IT.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (PR.NRORG = :P_NRORG) AND (TR.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (PF.NRORG = :P_NRORG) AND (RE.NRLANCESTQ = IT.NRLANCESTQ) AND (RE.CDFILANCESTQ = IT.CDFILIAL) AND (RE.CDFILANCESTQ = L.CDFILIAL) AND (RE.NRLANCESTQ = L.NRLANCESTQ) AND (RE.CDFILANCESTQ = F.CDFILIAL) AND (IT.CDFILIMOVI = :P_CDFILIAL) AND (IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S' ) AND (IT.IDTIPOMOVI = '3') AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (IT.CDPRODMOVI = PR.CDPRODUTO) AND (IT.CDTIPORETI = TR.CDTIPORETI) AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (PF.CDFILIAL = IT.CDFILIMOVI) AND (PF.CDPRODUTO = IT.CDPRODMOVI) AND (PF.IDCNTRESTOQ = 'S') AND (F.CDEMPRESA = :P_CDEMPRESA) GROUP BY IT.CDFILIMOVI, TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, F.CDCENTCUST, IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI), PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV UNION ALL /* SELECT REFERENTE AS RETIRADAS PRODUTO ACABADO DO ESTOQUE */ SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, TO_DATE(:P_DTCONTAB, 'DD/MM/YY') AS DTCONTAB, SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, FI.CDCENTCUST AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, P.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(P.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, P.CDARVPROD AS CODIGOPROD, P.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(P.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM CTRLMOVIESTQ C, ITLANCTOEST IT, FILIAL FI, PRODUTO P, TIPORETI TR, LOCALESTOQUE LE, ALMOXARIFADO AX, PRODFILI PR, CONTOPECTBL CP, HISTPADR HP WHERE FI.CDEMPRESA = :P_CDEMPRESA AND C.NRORG = :P_NRORG AND IT.NRORG = :P_NRORG AND FI.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND TR.NRORG = :P_NRORG AND LE.NRORG = :P_NRORG AND AX.NRORG = :P_NRORG AND PR.NRORG = :P_NRORG AND CP.NRORG = :P_NRORG AND HP.NRORG = :P_NRORG AND IT.IDTIPOMOVI = '3' AND IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL AND (INSTR(:P_CDFILIAL, IT.CDFILIMOVI) <> 0) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND IT.CDFILIAL = C.CDFILIALSAID AND IT.CDFILIMOVI = C.CDFILIAL AND IT.NRLANCESTQ = C.NRLANESTSAID AND IT.DTLANCMOVI = C.DTMOVIESTQ AND IT.CDPRODUTO = P.CDPRODUTO AND IT.CDTIPORETI = TR.CDTIPORETI AND C.CDFILIAL = FI.CDFILIAL AND C.CDFILIAL = LE.CDFILIAL AND C.CDALMOXENTR = LE.CDALMOXARIFE AND C.CDLCESTENTR = LE.CDLOCALESTOQ AND C.CDFILIAL = AX.CDFILIAL AND C.CDALMOXENTR = AX.CDALMOXARIFE AND C.CDFILIAL = AX.CDFILIAL AND C.CDALMOXENTR = AX.CDALMOXARIFE AND PR.CDPRODUTO = P.CDPRODUTO /*AND PR.CDFILIAL = C.CDFILIALSAID*/ AND PR.CDFILIAL = IT.CDFILIMOVI AND NVL(PR.IDPRODATIV,'A') = 'A' AND FI.CDEMPRESA = CP.CDEMPRESA AND HP.CDHISTPADR = TR.CDHISTPADR HAVING SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) <> 0 GROUP BY IT.CDFILIMOVI , TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, IT.IDTIPOMOVI, FI.CDCENTCUST , CENTCUST_PRODUTO(IT.CDFILIMOVI, P.CDARVPROD, 'S'), CONTCTBL_PRODUTO(P.CDPRODUTO,'E', IT.CDFILIMOVI) , P.CDARVPROD, P.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(P.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV ORDER BY 5, 9, 11, 12, 13";
    private $sql_adqGeraLoteDtMovi         = "SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, IT.DTLANCMOVI AS DTCONTAB, SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, DECODE(C.IDRETESTSETOR, 'S', NVL(S.CDCENTCUST, F.CDCENTCUST), F.CDCENTCUST) AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM PRODUTO PR, LOCALESTOQUE LE, HISTPADR HP, CONTOPECTBL C, LANCTOESTOQ L, FILIAL F, PRODFILI PF, RETIRADAESTO R LEFT JOIN SETOR S ON R.CDSETOR = S.CDSETOR AND S.NRORG = :P_NRORG, ITLANCTOEST IT LEFT JOIN PARAMAN PM ON PM.CDFILIAL = IT.CDFILIMOVI AND PM.CDTIPORETI <> IT.CDTIPORETI AND PM.NRORG = :P_NRORG LEFT JOIN TIPORETI TR ON IT.CDTIPORETI = TR.CDTIPORETI AND TR.NRORG = :P_NRORG LEFT JOIN ITREQUESTO IR ON IT.CDFILIAL = IR.CDFILILANC AND IT.NRLANCESTQ = IR.NRLANCESTQ AND IT.NRSEQUITEM = IR.NRSEQUITEM AND IT.CDPRODMOVI = IR.CDPRODUTO AND IR.NRORG = :P_NRORG WHERE(PR.NRORG = :P_NRORG) AND (LE.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (C.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (PF.NRORG = :P_NRORG) AND (PR.CDPRODUTO = IT.CDPRODMOVI) AND (it.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (IT.IDTIPOMOVI = '3' ) AND (IT.CDFILIMOVI = :P_CDFILIAL) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (IT.CDFILIMOVI = LE.CDFILIAL ) AND (IT.CDALMOXARIFE = LE.CDALMOXARIFE) AND (IT.CDLOCALESTOQ = LE.CDLOCALESTOQ) AND (L.CDFILIAL = R.CDFILIALLAN) AND (IT.CDFILIMOVI = LE.CDFILIAL ) AND (IT.CDALMOXARIFE = LE.CDALMOXARIFE) AND (IT.CDLOCALESTOQ = LE.CDLOCALESTOQ) AND (L.NRLANCESTQ = R.NRLANCESTQ ) AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S' ) AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (IT.CDFILIMOVI = F.CDFILIAL) AND (PF.CDFILIAL = IT.CDFILIMOVI) AND (PF.CDPRODUTO = IT.CDPRODMOVI) AND (IT.CDLOTEITCTB IS NULL) AND (IT.CDEMPITCTB IS NULL) AND (PF.IDCNTRESTOQ = 'S') AND (F.CDEMPRESA = C.CDEMPRESA) AND (NOT EXISTS (SELECT 1 FROM ORDPRODUCAO OP WHERE R.NRORDPROD = OP.NRORDPROD AND R.NRSUBORDPROD = OP.NRSUBORDPROD AND R.CDFILIAL = OP.CDFILIAL)) GROUP BY IT.CDFILIMOVI , TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, IT.IDTIPOMOVI, DECODE(C.IDRETESTSETOR, 'S', NVL(S.CDCENTCUST, F.CDCENTCUST), F.CDCENTCUST) , CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) , PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV, IT.DTLANCMOVI UNION ALL SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, IT.DTLANCMOVI AS DTCONTAB, SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, F.CDCENTCUST CDCENTCUSTDB, IT.IDTIPOMOVI AS IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM RETIRADA RE, ITLANCTOEST IT, LANCTOESTOQ L, FILIAL F, PRODUTO PR, TIPORETI TR, HISTPADR HP, PRODFILI PF WHERE (RE.NRORG = :P_NRORG) AND (IT.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (PR.NRORG = :P_NRORG) AND (TR.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (PF.NRORG = :P_NRORG) AND (RE.NRLANCESTQ = IT.NRLANCESTQ) AND (RE.CDFILANCESTQ = IT.CDFILIAL) AND (RE.CDFILANCESTQ = L.CDFILIAL) AND (RE.NRLANCESTQ = L.NRLANCESTQ) AND (RE.CDFILANCESTQ = F.CDFILIAL) AND (IT.CDFILIMOVI = :P_CDFILIAL) AND (IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S' ) AND (IT.IDTIPOMOVI = '3') AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (IT.CDPRODMOVI = PR.CDPRODUTO) AND (IT.CDTIPORETI = TR.CDTIPORETI) AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (PF.CDFILIAL = IT.CDFILIMOVI) AND (PF.CDPRODUTO = IT.CDPRODMOVI) AND (PF.IDCNTRESTOQ = 'S') AND (F.CDEMPRESA = :P_CDEMPRESA) GROUP BY IT.CDFILIMOVI, TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, F.CDCENTCUST, IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI), PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV, IT.DTLANCMOVI UNION ALL /* SELECT REFERENTE AS RETIRADAS PRODUTO ACABADO DO ESTOQUE */ SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, IT.DTLANCMOVI AS DTCONTAB, SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, FI.CDCENTCUST AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, P.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(P.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, P.CDARVPROD AS CODIGOPROD, P.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(P.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM CTRLMOVIESTQ C, ITLANCTOEST IT, FILIAL FI, PRODUTO P, TIPORETI TR, LOCALESTOQUE LE, ALMOXARIFADO AX, PRODFILI PR, CONTOPECTBL CP, HISTPADR HP WHERE FI.CDEMPRESA = :P_CDEMPRESA AND C.NRORG = :P_NRORG AND IT.NRORG = :P_NRORG AND FI.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND TR.NRORG = :P_NRORG AND LE.NRORG = :P_NRORG AND AX.NRORG = :P_NRORG AND PR.NRORG = :P_NRORG AND CP.NRORG = :P_NRORG AND HP.NRORG = :P_NRORG AND IT.IDTIPOMOVI = '3' AND IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL AND (INSTR(:P_CDFILIAL, IT.CDFILIMOVI) <> 0) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND IT.CDFILIAL = C.CDFILIALSAID AND IT.CDFILIMOVI = C.CDFILIAL AND IT.NRLANCESTQ = C.NRLANESTSAID AND IT.DTLANCMOVI = C.DTMOVIESTQ AND IT.CDPRODUTO = P.CDPRODUTO AND IT.CDTIPORETI = TR.CDTIPORETI AND C.CDFILIAL = FI.CDFILIAL AND C.CDFILIAL = LE.CDFILIAL AND C.CDALMOXENTR = LE.CDALMOXARIFE AND C.CDLCESTENTR = LE.CDLOCALESTOQ AND C.CDFILIAL = AX.CDFILIAL AND C.CDALMOXENTR = AX.CDALMOXARIFE AND C.CDFILIAL = AX.CDFILIAL AND C.CDALMOXENTR = AX.CDALMOXARIFE AND PR.CDPRODUTO = P.CDPRODUTO AND PR.CDFILIAL = IT.CDFILIMOVI AND NVL(PR.IDPRODATIV,'A') = 'A' AND FI.CDEMPRESA = CP.CDEMPRESA AND HP.CDHISTPADR = TR.CDHISTPADR HAVING SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) <> 0 GROUP BY IT.CDFILIMOVI , TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, IT.IDTIPOMOVI, FI.CDCENTCUST , CENTCUST_PRODUTO(IT.CDFILIMOVI, P.CDARVPROD, 'S'), CONTCTBL_PRODUTO(P.CDPRODUTO,'E', IT.CDFILIMOVI) , P.CDARVPROD, P.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(P.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV, IT.DTLANCMOVI ORDER BY 5, 9, 11, 12, 13";
    private $sql_adqGeraLoteCustLanc       = "SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, TO_DATE(:P_DTCONTAB, 'DD/MM/YY') AS DTCONTAB, SUM(IT.VRTOTLANCTO) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, DECODE(C.IDRETESTSETOR, 'S', NVL(S.CDCENTCUST, F.CDCENTCUST), F.CDCENTCUST) AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM PRODUTO PR, LOCALESTOQUE LE, HISTPADR HP, LANCTOESTOQ L, FILIAL F, CONTOPECTBL C, RETIRADAESTO R LEFT JOIN SETOR S ON R.CDSETOR = S.CDSETOR, ITLANCTOEST IT LEFT JOIN PARAMAN PM ON PM.CDFILIAL = IT.CDFILIMOVI AND PM.CDTIPORETI <> IT.CDTIPORETI AND PM.NRORG = :P_NRORG LEFT JOIN TIPORETI TR ON IT.CDTIPORETI = TR.CDTIPORETI AND TR.NRORG = :P_NRORG LEFT JOIN ITREQUESTO IR ON IT.NRLANCESTQ = IR.NRLANCESTQ AND IT.NRSEQUITEM = IR.NRSEQUITEM AND IT.CDPRODMOVI = IR.CDPRODUTO AND IT.CDFILIAL = IR.CDFILILANC AND IR.NRORG = :P_NRORG WHERE(PR.NRORG = :P_NRORG) AND (LE.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (C.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (IT.NRORG = :P_NRORG) AND (PR.CDPRODUTO = IT.CDPRODMOVI) AND (it.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (IT.IDTIPOMOVI = '3' ) AND (IT.CDFILIMOVI = :P_CDFILIAL ) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (IT.CDFILIMOVI = LE.CDFILIAL ) AND (IT.CDALMOXARIFE = LE.CDALMOXARIFE) AND (IT.CDLOCALESTOQ = LE.CDLOCALESTOQ) AND (L.CDFILIAL = R.CDFILIALLAN) AND (L.NRLANCESTQ = R.NRLANCESTQ ) AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (IT.CDFILIMOVI = F.CDFILIAL) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S') AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (F.CDEMPRESA = C.CDEMPRESA) AND (NOT EXISTS (SELECT 1 FROM ORDPRODUCAO OP WHERE R.NRORDPROD = OP.NRORDPROD AND R.NRSUBORDPROD = OP.NRSUBORDPROD AND R.CDFILIAL = OP.CDFILIAL)) GROUP BY IT.CDFILIMOVI, TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, DECODE(C.IDRETESTSETOR, 'S', NVL(S.CDCENTCUST, F.CDCENTCUST), F.CDCENTCUST), IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI), PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV UNION ALL SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, TO_DATE(:P_DTCONTAB, 'DD/MM/YY') AS DTCONTAB, SUM(IT.VRTOTLANCTO) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, F.CDCENTCUST CDCENTCUSTDB, IT.IDTIPOMOVI AS IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM RETIRADA RE, ITLANCTOEST IT, LANCTOESTOQ L, FILIAL F, PRODUTO PR, TIPORETI TR, HISTPADR HP WHERE (RE.NRORG = :P_NRORG) AND (IT.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (PR.NRORG = :P_NRORG) AND (TR.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (RE.NRLANCESTQ = IT.NRLANCESTQ) AND (RE.CDFILANCESTQ = IT.CDFILIAL) AND (RE.CDFILANCESTQ = L.CDFILIAL) AND (RE.NRLANCESTQ = L.NRLANCESTQ) AND (RE.CDFILANCESTQ = F.CDFILIAL) AND (IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (IT.CDFILIMOVI = :P_CDFILIAL ) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S' ) AND (IT.IDTIPOMOVI = '3') AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (IT.CDPRODMOVI = PR.CDPRODUTO) AND (IT.CDTIPORETI = TR.CDTIPORETI) AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (F.CDEMPRESA = :P_CDEMPRESA) GROUP BY IT.CDFILIMOVI , TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI,F.CDCENTCUST, IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI), PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV UNION ALL /* SELECT REFERENTE AS RETIRADAS PRODUTO ACABADO DO ESTOQUE */ SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, TO_DATE(:P_DTCONTAB, 'DD/MM/YY') AS DTCONTAB, SUM(IT.VRTOTLANCTO) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, FI.CDCENTCUST AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, P.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(P.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, P.CDARVPROD AS CODIGOPROD, P.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(P.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM CTRLMOVIESTQ C, ITLANCTOEST IT, FILIAL FI, PRODUTO P, TIPORETI TR, LOCALESTOQUE LE, ALMOXARIFADO AX, PRODFILI PR, CONTOPECTBL CP, HISTPADR HP WHERE FI.CDEMPRESA = :P_CDEMPRESA AND C.NRORG = :P_NRORG AND IT.NRORG = :P_NRORG AND FI.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND TR.NRORG = :P_NRORG AND LE.NRORG = :P_NRORG AND AX.NRORG = :P_NRORG AND PR.NRORG = :P_NRORG AND CP.NRORG = :P_NRORG AND HP.NRORG = :P_NRORG AND IT.IDTIPOMOVI = '3' AND IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL AND (INSTR(:P_CDFILIAL, IT.CDFILIMOVI) <> 0) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND IT.CDFILIAL = C.CDFILIALSAID AND IT.CDFILIMOVI = C.CDFILIAL AND IT.NRLANCESTQ = C.NRLANESTSAID AND IT.DTLANCMOVI = C.DTMOVIESTQ AND IT.CDPRODUTO = P.CDPRODUTO AND IT.CDTIPORETI = TR.CDTIPORETI AND C.CDFILIAL = FI.CDFILIAL AND C.CDFILIAL = LE.CDFILIAL AND C.CDALMOXENTR = LE.CDALMOXARIFE AND C.CDLCESTENTR = LE.CDLOCALESTOQ AND C.CDFILIAL = AX.CDFILIAL AND C.CDALMOXENTR = AX.CDALMOXARIFE AND C.CDFILIAL = AX.CDFILIAL AND C.CDALMOXENTR = AX.CDALMOXARIFE AND PR.CDPRODUTO = P.CDPRODUTO /*AND PR.CDFILIAL = C.CDFILIALSAID*/ AND PR.CDFILIAL = IT.CDFILIMOVI AND NVL(PR.IDPRODATIV,'A') = 'A' AND FI.CDEMPRESA = CP.CDEMPRESA AND HP.CDHISTPADR = TR.CDHISTPADR HAVING SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) <> 0 GROUP BY IT.CDFILIMOVI, TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, FI.CDCENTCUST, IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, P.CDARVPROD, 'S'), CONTCTBL_PRODUTO(P.CDPRODUTO,'E', IT.CDFILIMOVI), P.CDARVPROD, P.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(P.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV ORDER BY 5, 9, 11, 12, 13";
    private $sql_adqGeraLoteCustLancDtMovi = "SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, IT.DTLANCMOVI AS DTCONTAB, SUM(IT.VRTOTLANCTO) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, DECODE(C.IDRETESTSETOR, 'S', NVL(S.CDCENTCUST, F.CDCENTCUST), F.CDCENTCUST) AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM PRODUTO PR, LOCALESTOQUE LE, HISTPADR HP, LANCTOESTOQ L, FILIAL F, CONTOPECTBL C, RETIRADAESTO R LEFT JOIN SETOR S ON R.CDSETOR = S.CDSETOR, ITLANCTOEST IT LEFT JOIN PARAMAN PM ON PM.CDFILIAL = IT.CDFILIMOVI AND PM.CDTIPORETI <> IT.CDTIPORETI AND PM.NRORG = :P_NRORG LEFT JOIN TIPORETI TR ON IT.CDTIPORETI = TR.CDTIPORETI AND TR.NRORG = :P_NRORG LEFT JOIN ITREQUESTO IR ON IT.NRLANCESTQ = IR.NRLANCESTQ AND IT.NRSEQUITEM = IR.NRSEQUITEM AND IT.CDPRODMOVI = IR.CDPRODUTO AND IT.CDFILIAL = IR.CDFILILANC AND IR.NRORG = :P_NRORG WHERE(PR.NRORG = :P_NRORG) AND (LE.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (C.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (IT.NRORG = :P_NRORG) AND (PR.CDPRODUTO = IT.CDPRODMOVI) AND (it.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (IT.IDTIPOMOVI = '3' ) AND (IT.CDFILIMOVI = :P_CDFILIAL ) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (IT.CDFILIMOVI = LE.CDFILIAL ) AND (IT.CDALMOXARIFE = LE.CDALMOXARIFE) AND (IT.CDLOCALESTOQ = LE.CDLOCALESTOQ) AND (L.CDFILIAL = R.CDFILIALLAN) AND (L.NRLANCESTQ = R.NRLANCESTQ ) AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (IT.CDFILIMOVI = F.CDFILIAL) AND (IT.CDLOTEITCTB IS NULL) AND (IT.CDEMPITCTB IS NULL) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S') AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (F.CDEMPRESA = C.CDEMPRESA) AND (NOT EXISTS (SELECT 1 FROM ORDPRODUCAO OP WHERE R.NRORDPROD = OP.NRORDPROD AND R.NRSUBORDPROD = OP.NRSUBORDPROD AND R.CDFILIAL = OP.CDFILIAL)) GROUP BY IT.CDFILIMOVI, TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, DECODE(C.IDRETESTSETOR, 'S', NVL(S.CDCENTCUST, F.CDCENTCUST), F.CDCENTCUST), IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI), PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV,IT.DTLANCMOVI UNION ALL SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, IT.DTLANCMOVI AS DTCONTAB, SUM(IT.VRTOTLANCTO) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, F.CDCENTCUST CDCENTCUSTDB, IT.IDTIPOMOVI AS IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM RETIRADA RE, ITLANCTOEST IT, LANCTOESTOQ L, FILIAL F, PRODUTO PR, TIPORETI TR, HISTPADR HP WHERE (RE.NRORG = :P_NRORG) AND (IT.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (PR.NRORG = :P_NRORG) AND (TR.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (RE.NRLANCESTQ = IT.NRLANCESTQ) AND (RE.CDFILANCESTQ = IT.CDFILIAL) AND (RE.CDFILANCESTQ = L.CDFILIAL) AND (RE.NRLANCESTQ = L.NRLANCESTQ) AND (RE.CDFILANCESTQ = F.CDFILIAL) AND (IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (IT.CDFILIMOVI = :P_CDFILIAL ) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S' ) AND (IT.IDTIPOMOVI = '3') AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (IT.CDPRODMOVI = PR.CDPRODUTO) AND (IT.CDTIPORETI = TR.CDTIPORETI) AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (F.CDEMPRESA = :P_CDEMPRESA) GROUP BY IT.CDFILIMOVI , TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI,F.CDCENTCUST, IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CONTCTBL_PRODUTO(PR.CDPRODUTO,'E', IT.CDFILIMOVI), PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(PR.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV, IT.DTLANCMOVI UNION ALL /* SELECT REFERENTE AS RETIRADAS PRODUTO ACABADO DO ESTOQUE */ SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, IT.DTLANCMOVI AS DTCONTAB, SUM(IT.VRTOTLANCTO) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, FI.CDCENTCUST AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, P.CDARVPROD, 'S') AS CDCENTCUSTCR, CONTCTBL_PRODUTO(P.CDPRODUTO,'E', IT.CDFILIMOVI) AS CDCTBLENTRPR, P.CDARVPROD AS CODIGOPROD, P.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(P.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL) CDCONTCTBL, TR.IDCONTABCMV FROM CTRLMOVIESTQ C, ITLANCTOEST IT, FILIAL FI, PRODUTO P, TIPORETI TR, LOCALESTOQUE LE, ALMOXARIFADO AX, PRODFILI PR, CONTOPECTBL CP, HISTPADR HP WHERE FI.CDEMPRESA = :P_CDEMPRESA AND C.NRORG = :P_NRORG AND IT.NRORG = :P_NRORG AND FI.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND TR.NRORG = :P_NRORG AND LE.NRORG = :P_NRORG AND AX.NRORG = :P_NRORG AND PR.NRORG = :P_NRORG AND CP.NRORG = :P_NRORG AND HP.NRORG = :P_NRORG AND IT.IDTIPOMOVI = '3' AND IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL AND (INSTR(:P_CDFILIAL, IT.CDFILIMOVI) <> 0) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND IT.CDFILIAL = C.CDFILIALSAID AND IT.CDFILIMOVI = C.CDFILIAL AND IT.NRLANCESTQ = C.NRLANESTSAID AND IT.DTLANCMOVI = C.DTMOVIESTQ AND IT.CDPRODUTO = P.CDPRODUTO AND IT.CDTIPORETI = TR.CDTIPORETI AND C.CDFILIAL = FI.CDFILIAL AND C.CDFILIAL = LE.CDFILIAL AND C.CDALMOXENTR = LE.CDALMOXARIFE AND C.CDLCESTENTR = LE.CDLOCALESTOQ AND C.CDFILIAL = AX.CDFILIAL AND C.CDALMOXENTR = AX.CDALMOXARIFE AND C.CDFILIAL = AX.CDFILIAL AND C.CDALMOXENTR = AX.CDALMOXARIFE AND PR.CDPRODUTO = P.CDPRODUTO /*AND PR.CDFILIAL = C.CDFILIALSAID*/ AND PR.CDFILIAL = IT.CDFILIMOVI AND NVL(PR.IDPRODATIV,'A') = 'A' AND FI.CDEMPRESA = CP.CDEMPRESA AND HP.CDHISTPADR = TR.CDHISTPADR GROUP BY IT.CDFILIMOVI, TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI, FI.CDCENTCUST, IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, P.CDARVPROD, 'S'), CONTCTBL_PRODUTO(P.CDPRODUTO,'E', IT.CDFILIMOVI), P.CDARVPROD, P.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CONTCTBL_PRODUTO(P.CDPRODUTO,'M', IT.CDFILIMOVI),TR.CDCONTCTBL), TR.IDCONTABCMV, IT.DTLANCMOVI ORDER BY 5, 9, 11, 12, 13";
    private $sql_adqVerLote                = "SELECT CDLOTE FROM CAPALOTE WHERE CDEMPRESA = :P_CDEMPRESA AND CDLOTE = :P_CDLOTE AND NRORG = :P_NRORG";
    private $sql_ExistLancLote             = "SELECT L.CDLOTE FROM LANCLOTE L WHERE L.CDEMPRESA = :P_CDEMPRESA AND L.CDLOTE = :P_CDLOTE AND L.NRORG = :P_NRORG";
    private $sql_acmCapaLote               = "INSERT INTO CAPALOTE(NRORG, CDLOTE, CDEMPRESA, DSOBSELOTE, IDLOTE, DTINICLOTE, DTFINALOTE) VALUES(:P_NRORG, :P_CDLOTE, :P_CDEMPRESA, :P_DSOBSELOTE, :P_IDLOTE, :P_DTINICLOTE, :P_DTFINALOTE)";
    private $sql_acmLancLote               = "INSERT INTO LANCLOTE(NRORG, CDEMPRESA, CDLOTE, NRLANCLOTE, NRSEQLANLOTE, CDCONTCTBL, CDHISTPADR, DTLANCLOTE, NRDOCULOTE, DSHISTLOTE, VRLANCLOTE) VALUES(:P_NRORG, :P_CDEMPRESA, :P_CDLOTE, :P_NRLANCLOTE, :P_NRSEQLANLOTE, :P_CDCONTCTBL, :P_CDHISTPADR, :P_DTLANCLOTE, :P_NRDOCULOTE, :P_DSHISTLOTE, :P_VRLANCLOTE)";
    private $sql_adqContCtbl               = "SELECT CDCONTCTBL, IDCONTCCUS FROM CONTCTBL WHERE CDCONTCTBL = :P_CDCONTCTBL AND NRORG = :P_NRORG";
    private $sql_acmRatCusto               = "INSERT INTO RATECCUS( NRORG, CDEMPRESA, CDLOTE, NRLANCLOTE, NRSEQLANLOTE, CDFILIAL, CDCENTCUST, DTCOMPRATECCUS, VRRATECCUS) VALUES(:P_NRORG, :P_CDEMPRESA, :P_CDLOTE, :P_NRLANCLOTE, :P_NRSEQLANLOTE, :P_CDFILIAL, :P_CDCENTCUST, :P_DTCOMPRATECCUS, :P_VRRATECCUS)";
    private $sql_adqProdSemCContabil       = "SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, TO_DATE(:P_DTCONTAB, 'DD/MM/YY') AS DTCONTAB, SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI , F.CDCENTCUST AS CDCENTCUSTDB, IT.IDTIPOMOVI IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CTBL_PRODUTO(PR.CDPRODUTO,'E') AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CTBL_CMV(PR.CDPRODUTO),TR.CDCONTCTBL) CDCONTCTBL FROM ITLANCTOEST IT, PRODUTO PR, ITREQUESTO IR, LOCALESTOQUE LE, TIPORETI TR, PARAMAN PM, HISTPADR HP, RETIRADAESTO R, setor s, LANCTOESTOQ L, FILIAL F WHERE(IT.NRORG = :P_NRORG) AND (PR.NRORG = :P_NRORG) AND (IR.NRORG = :P_NRORG) AND (LE.NRORG = :P_NRORG) AND (TR.NRORG = :P_NRORG) AND (PM.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (S.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (PR.CDPRODUTO = IT.CDPRODMOVI) AND (it.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (IT.IDTIPOMOVI = '3' ) AND (INSTR(:P_CDFILIAL, IT.CDFILIMOVI) <> 0) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (IT.CDFILIMOVI = LE.CDFILIAL ) AND (PM.CDFILIAL = IT.CDFILIMOVI) AND (PM.CDTIPORETI <> IT.CDTIPORETI) AND (CTBL_PRODUTO(PR.CDPRODUTO,'E') IS NULL) AND (IT.CDALMOXARIFE = LE.CDALMOXARIFE) AND (IT.CDLOCALESTOQ = LE.CDLOCALESTOQ) AND (L.CDFILIAL = R.CDFILIALLAN) AND (L.NRLANCESTQ = R.NRLANCESTQ ) AND (R.CDSETOR = S.CDSETOR(+) ) AND (R.CDCENTCUST = S.CDCENTCUST(+)) AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND ((R.CDCENTCUST IS NOT NULL) OR (R.CDCENTCUST <> '') ) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S' ) AND (IT.CDTIPORETI = TR.CDTIPORETI(+)) AND (IT.CDFILIAL = IR.CDFILILANC(+) ) AND (HP.CDHISTPADR = TR.CDHISTPADR) AND (IT.NRLANCESTQ = IR.NRLANCESTQ(+)) AND (IT.NRSEQUITEM = IR.NRSEQUITEM(+)) AND (IT.CDPRODMOVI = IR.CDPRODUTO (+)) AND (IT.CDFILIMOVI = F.CDFILIAL) AND (NOT EXISTS (SELECT 1 FROM ORDPRODUCAO OP WHERE R.NRORDPROD = OP.NRORDPROD AND R.NRSUBORDPROD = OP.NRSUBORDPROD AND R.CDFILIAL = OP.CDFILIAL)) GROUP BY IT.CDFILIMOVI , TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI , F.CDCENTCUST, IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CTBL_PRODUTO(PR.CDPRODUTO,'E') , PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CTBL_CMV(PR.CDPRODUTO),TR.CDCONTCTBL) UNION ALL SELECT TO_DATE(:P_DTINICIAL, 'DD/MM/YY') AS DTINICIAL, TO_DATE(:P_DTFINAL, 'DD/MM/YY') AS DTFINAL, TO_DATE(:P_DTCONTAB, 'DD/MM/YY') AS DTCONTAB, SUM(CUSTO_PRODUTO_LCEST(IT.CDFILIMOVI, IT.CDPRODMOVI, 3, IT.DTLANCMOVI, SYSDATE, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE) * IT.QTLANCTOEST) AS VRCUSTPROD, IT.CDFILIMOVI AS CDFILIMOVI , TR.CDHISTPADR AS CDHISTPADR, HP.DSHISTPADR AS DSHISTPADR, IT.CDTIPORETI AS CDTIPORETI, F.CDCENTCUST CDCENTCUSTDB, IT.IDTIPOMOVI AS IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S') AS CDCENTCUSTCR, CTBL_PRODUTO(PR.CDPRODUTO,'E') AS CDCTBLENTRPR, PR.CDARVPROD AS CODIGOPROD, PR.NMPRODUTO AS NOMEPROD, DECODE(TR.IDCONTABCMV,'S',CTBL_CMV(PR.CDPRODUTO),TR.CDCONTCTBL) CDCONTCTBL FROM ITLANCTOEST IT, PRODUTO PR, LOCALESTOQUE LE, TIPORETI TR, HISTPADR HP, RETIRADA RE, LANCTOESTOQ L, FILIAL F WHERE (IT.NRORG = :P_NRORG) AND (PR.NRORG = :P_NRORG) AND (LE.NRORG = :P_NRORG) AND (TR.NRORG = :P_NRORG) AND (HP.NRORG = :P_NRORG) AND (L.NRORG = :P_NRORG) AND (F.NRORG = :P_NRORG) AND (PR.CDPRODUTO = IT.CDPRODMOVI ) AND (IT.DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL) AND (IT.IDTIPOMOVI = '3' ) AND (INSTR(:P_CDFILIAL, IT.CDFILIMOVI) <> 0) AND (INSTR(:P_CDTIPORETI, IT.CDTIPORETI) <> 0) AND (IT.CDFILIMOVI = LE.CDFILIAL ) AND (CTBL_PRODUTO(PR.CDPRODUTO,'E') IS NULL) AND (IT.CDALMOXARIFE = LE.CDALMOXARIFE) AND (IT.CDLOCALESTOQ = LE.CDLOCALESTOQ) AND (RE.CDFILANCESTQ = F.CDFILIAL) AND (L.CDFILIAL = RE.CDFILANCESTQ) AND (L.NRLANCESTQ = RE.NRLANCESTQ) AND (IT.CDFILIAL = L.CDFILIAL) AND (IT.NRLANCESTQ = L.NRLANCESTQ) AND (NVL(IT.IDEVOLESTOQ, 'S') = 'S' ) AND (IT.CDTIPORETI = TR.CDTIPORETI(+)) AND (HP.CDHISTPADR (+) = TR.CDHISTPADR) GROUP BY IT.CDFILIMOVI , TR.CDHISTPADR, HP.DSHISTPADR, IT.CDTIPORETI,F.CDCENTCUST, IT.IDTIPOMOVI, CENTCUST_PRODUTO(IT.CDFILIMOVI, PR.CDARVPROD, 'S'), CTBL_PRODUTO(PR.CDPRODUTO,'E') , PR.CDARVPROD, PR.NMPRODUTO, DECODE(TR.IDCONTABCMV,'S',CTBL_CMV(PR.CDPRODUTO),TR.CDCONTCTBL) ORDER BY 5, 9, 11, 12, 13";
    private $sql_acmUpdateItLancto         = "UPDATE ITLANCTOEST SET CDEMPITCTB = :P_CDEMPRESA, CDLOTEITCTB = :P_CDLOTE WHERE(IDTIPOMOVI = '3') AND (NRORG = :P_NRORG) AND (INSTR(:P_CDFILIAL, CDFILIMOVI) <> 0) AND (INSTR(:P_CDTIPORETI, CDTIPORETI) <> 0) AND (DTLANCMOVI BETWEEN :P_DTINICIAL AND :P_DTFINAL)";
    
    private $sql_qryFiliaisEmpr            = "SELECT CDFILIAL FROM FILIAL WHERE CDEMPRESA = :P_CDEMPRESA AND INSTR(:P_CDFILIAL, CDFILIAL) > 0 AND NRORG = :P_NRORG ORDER BY 1"; //Atenção: Usada nas funções qryFiliaisEmpr e adqFiliaisEmpr
    private $sql_adqCodProd                = "SELECT MIN(CDARVPROD) PRODINI, MAX(CDARVPROD) PRODFIN FROM PRODUTO WHERE NRORG = :P_NRORG";
    private $sql_adsMovi_EstoqueORA        = "BEGIN MOVIMENTACAO_ESTOQUE(:P_FILIAL, :P_CDALMOXARIFE, :P_CDLOCALESTOQ, :P_NRLOTEESTQ, :P_TAMNIVEL, :P_DTINICIAL, :P_DTFINAL, :P_PRODINI, :P_PRODFIM, :P_IDLANCTO, :P_IDCUSTO, :P_SEQUMOVI, :P_MOVCONSOLID, :P_DELMOVIMEN); END;";
    private $sql_adqGeraLote2              = "SELECT AJ.CDFILIMOVIEST, AJ.NRLANCMOVIEST, AJ.CDCONTCTBL, AJ.CDCTBLENTRPR, AJ.CDCENTCUST, SUM(ROUND(VRCUSTPROD, 2)) AS VRCUSTPROD FROM(SELECT LANC.CDFILIMOVIEST, LANC.CDCTBLENTRPR, LANC.CDCONTCTBL, LANC.NRLANCMOVIEST, LANC.CDCENTCUST, SUM(VRCUSTPROD) VRCUSTPROD FROM (SELECT DECODE(DECODE(R.QTLANCMOVIEST, 0, R.QTLANCAMENTO, R.QTLANCMOVIEST), 0, 0, VRDIFECUST) AS VRCUSTPROD, R.CDFILIMOVIEST, R.NRLANCMOVIEST, CONTCTBL_PRODUTO(P.CDPRODUTO, 'I', R.CDFILIMOVIEST) CDCONTCTBL, CONTCTBL_PRODUTO(P.CDPRODUTO, 'E', R.CDFILIMOVIEST) CDCTBLENTRPR, BUSCA_CCUSTO(F.CDFILIAL, F.CDEMPRESA) CDCENTCUST FROM RELAT_MOVIEST R, FILIAL F, PRODUTO P WHERE F.CDEMPRESA = :P_CDEMPRESA AND F.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND INSTR(:P_CDFILIAL, F.CDFILIAL) > 0 AND (R.NRRELATMOVI = :P_NRRELATMOVI) AND (R.CDFILIMOVIEST = F.CDFILIAL) AND (R.IDTIPOMOVIEST = '0') AND (R.CDPRODMOVIEST = P.CDARVPROD AND :P_IDTPLANC = 'I')) LANC GROUP BY LANC.CDFILIMOVIEST, LANC.CDCTBLENTRPR, LANC.CDCONTCTBL, LANC.NRLANCMOVIEST, LANC.CDCENTCUST ) AJ JOIN CONTCTBL C ON AJ.CDCTBLENTRPR = C.CDCONTCTBL AND C.NRORG = :P_NRORG JOIN CONTCTBL CO ON AJ.CDCONTCTBL = CO.CDCONTCTBL AND CO.NRORG = :P_NRORG WHERE ROUND(VRCUSTPROD, 2) <> 0 AND :P_IDTPLANC = 'I' GROUP BY AJ.CDFILIMOVIEST, AJ.NRLANCMOVIEST, AJ.CDCONTCTBL, AJ.CDCTBLENTRPR, AJ.CDCENTCUST UNION ALL SELECT AJ.CDFILIMOVIEST, AJ.NRLANCMOVIEST, AJ.CDCONTCTBL, AJ.CDCTBLENTRPR, AJ.CDCENTCUST, SUM(ROUND(VRCUSTPROD, 2)) AS VRCUSTPROD FROM (SELECT LANC.CDFILIMOVIEST, LANC.CDCTBLENTRPR, LANC.CDCONTCTBL, LANC.NRLANCMOVIEST, LANC.CDCENTCUST, SUM(VRCUSTPROD) VRCUSTPROD FROM (SELECT DECODE(R.QTLANCAMENTO, 0, 0, VRDIFECUST) AS VRCUSTPROD, R.CDFILIMOVIEST, R.NRLANCMOVIEST, CONTCTBL_PRODUTO(P.CDPRODUTO, 'A', R.CDFILIMOVIEST) CDCONTCTBL, CONTCTBL_PRODUTO(P.CDPRODUTO, 'E', R.CDFILIMOVIEST) CDCTBLENTRPR, BUSCA_CCUSTO(F.CDFILIAL, F.CDEMPRESA) CDCENTCUST FROM RELAT_MOVIEST R, FILIAL F, PRODUTO P WHERE (F.CDFILIAL = :P_CDFILIAL) AND F.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND (R.NRRELATMOVI = :P_NRRELATMOVI) AND (R.CDFILIMOVIEST = F.CDFILIAL) AND (R.IDTIPOMOVIEST = '1') AND (R.CDPRODMOVIEST = P.CDARVPROD AND :P_IDTPLANC = 'A') ) LANC GROUP BY LANC.CDFILIMOVIEST, LANC.CDCTBLENTRPR, LANC.CDCONTCTBL, LANC.NRLANCMOVIEST, LANC.CDCENTCUST ) AJ JOIN CONTCTBL C ON AJ.CDCTBLENTRPR = C.CDCONTCTBL AND C.NRORG = :P_NRORG JOIN CONTCTBL CO ON AJ.CDCONTCTBL = CO.CDCONTCTBL AND CO.NRORG = :P_NRORG WHERE ROUND(VRCUSTPROD, 2) <> 0 AND :P_IDTPLANC = 'A' GROUP BY AJ.CDFILIMOVIEST, AJ.NRLANCMOVIEST, AJ.CDCONTCTBL, AJ.CDCTBLENTRPR, AJ.CDCENTCUST ORDER BY 1, 2, 3, 4, 5";
    private $sql_adqRelatorioAnalAj        = "SELECT TO_DATE(:P_DTINICIAL) AS DTINICIAL, TO_DATE(:P_DTFINAL) AS DTFINAL, SUBSTR(:P_DATACONTAB,1, 10) AS DATACONTAB, TO_DATE(:P_DTCONTAB) AS DTCONTAB, SUBSTR(:P_NMTIPOCUSTO, 1, 50) AS NMTIPOCUSTO, AJ.CDFILIMOVIEST, AJ.CDPRODMOVIEST, AJ.DTLANCMOVIEST, AJ.QTLANCTOEST, AJ.NRLANCMOVIEST, AJ.NMPRODUTO, AJ.CDCONTCTBL, AJ.CDCTBLENTRPR, AJ.IDTIPOMOVIEST, AJ.VRCUSTPROD, DECODE(NVL(AJ.QTLANCTOEST, 0), 0, NULL, AJ.VRCUSTPROD / AJ.QTLANCTOEST) AS VRUNIT, AJ.NMCONTCTBL, C.NMCONTCTBL AS NMCTBLENTRPR, F.NMFILIAL FROM( SELECT LANC.CDFILIMOVIEST, LANC.CDPRODMOVIEST, LANC.DTLANCMOVIEST, SUM(LANC.QTLANCAMENTO) AS QTLANCTOEST, LANC.NRLANCMOVIEST, LANC.NMPRODUTO, LANC.CDCONTCTBL, LANC.CDCTBLENTRPR, LANC.IDTIPOMOVIEST, SUM(ROUND(VRCUSTPROD, 2)) VRCUSTPROD, C.NMCONTCTBL AS NMCONTCTBL FROM ( SELECT DECODE(R.QTLANCAMENTO, 0, 0, VRDIFECUST) AS VRCUSTPROD, R.CDFILIMOVIEST, R.CDPRODMOVIEST, R.DTLANCMOVIEST, R.QTLANCAMENTO, R.NRLANCMOVIEST, P.NMPRODUTO, CONTCTBL_PRODUTO(P.CDPRODUTO, 'A', R.CDFILIMOVIEST) CDCONTCTBL, CONTCTBL_PRODUTO(P.CDPRODUTO, 'E', R.CDFILIMOVIEST) CDCTBLENTRPR, R.IDTIPOMOVIEST FROM RELAT_MOVIEST R, FILIAL F, PRODUTO P WHERE F.CDEMPRESA = :P_CDEMPRESA AND F.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND ((INSTR(:P_CDFILIAL, F.CDFILIAL) > 0) OR ('T' = :P_CDFILIAL)) AND (R.NRRELATMOVI = :P_NRRELATMOVI) AND (R.CDFILIMOVIEST = F.CDFILIAL) AND (R.IDTIPOMOVIEST = '1') AND (R.CDPRODMOVIEST = P.CDARVPROD)) LANC LEFT JOIN CONTCTBL C ON LANC.CDCONTCTBL = C.CDCONTCTBL AND C.NRORG = :P_NRORG GROUP BY LANC.CDFILIMOVIEST, LANC.CDPRODMOVIEST, LANC.DTLANCMOVIEST, LANC.NRLANCMOVIEST, LANC.NMPRODUTO, LANC.CDCONTCTBL, LANC.CDCTBLENTRPR, LANC.IDTIPOMOVIEST, LANC.IDTIPOMOVIEST, C.NMCONTCTBL ) AJ LEFT JOIN CONTCTBL C ON AJ.CDCTBLENTRPR = C.CDCONTCTBL AND C.NRORG = :P_NRORG, FILIAL F WHERE AJ.CDFILIMOVIEST = F.CDFILIAL AND F.NRORG = :P_NRORG AND ROUND(VRCUSTPROD, 2) <> 0 ORDER BY AJ.DTLANCMOVIEST, AJ.NRLANCMOVIEST, AJ.CDFILIMOVIEST, AJ.CDCTBLENTRPR, AJ.CDPRODMOVIEST, AJ.CDCONTCTBL";
    private $sql_adqRelatorioAnalImp       = "SELECT TO_DATE(:P_DTINICIAL) AS DTINICIAL, TO_DATE(:P_DTFINAL) AS DTFINAL, SUBSTR(:P_DATACONTAB,1, 10) AS DATACONTAB, TO_DATE(:P_DTCONTAB) AS DTCONTAB, SUBSTR(:P_NMTIPOCUSTO, 1, 50) AS NMTIPOCUSTO, IMP.CDFILIMOVIEST, IMP.CDPRODMOVIEST, IMP.DTLANCMOVIEST, IMP.QTLANCTOEST, IMP.NRLANCMOVIEST, IMP.NMPRODUTO, IMP.CDCONTCTBL, IMP.CDCTBLENTRPR, IMP.IDTIPOMOVIEST, IMP.VRCUSTPROD, DECODE(NVL(IMP.QTLANCTOEST, 0), 0, NULL, IMP.VRCUSTPROD / IMP.QTLANCTOEST) AS VRUNIT, IMP.NMCONTCTBL, C.NMCONTCTBL AS NMCTBLENTRPR, F.NMFILIAL FROM( SELECT LANC.CDFILIMOVIEST, LANC.CDPRODMOVIEST, LANC.DTLANCMOVIEST, SUM(LANC.QTLANCAMENTO) AS QTLANCTOEST, LANC.NRLANCMOVIEST, LANC.NMPRODUTO, LANC.CDCONTCTBL, LANC.CDCTBLENTRPR, LANC.IDTIPOMOVIEST, SUM(VRCUSTPROD) VRCUSTPROD, C.NMCONTCTBL AS NMCONTCTBL FROM ( SELECT DECODE(DECODE(R.QTLANCMOVIEST, 0, R.QTLANCAMENTO, R.QTLANCMOVIEST), 0, 0, VRDIFECUST) AS VRCUSTPROD, R.CDFILIMOVIEST, R.CDPRODMOVIEST, R.DTLANCMOVIEST, R.QTLANCAMENTO, R.NRLANCMOVIEST, P.NMPRODUTO, CONTCTBL_PRODUTO(P.CDPRODUTO, 'I', R.CDFILIMOVIEST) CDCONTCTBL, CONTCTBL_PRODUTO(P.CDPRODUTO, 'E', R.CDFILIMOVIEST) CDCTBLENTRPR, R.IDTIPOMOVIEST FROM RELAT_MOVIEST R, FILIAL F, PRODUTO P WHERE F.CDEMPRESA = :P_CDEMPRESA AND F.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND ((INSTR(:P_CDFILIAL, F.CDFILIAL) > 0) OR ('T' = :P_CDFILIAL)) AND (R.NRRELATMOVI = :P_NRRELATMOVI) AND (R.CDFILIMOVIEST = F.CDFILIAL) AND (R.IDTIPOMOVIEST = '0') AND (R.CDPRODMOVIEST = P.CDARVPROD)) LANC LEFT JOIN CONTCTBL C ON LANC.CDCONTCTBL = C.CDCONTCTBL AND C.NRORG = :P_NRORG GROUP BY LANC.CDFILIMOVIEST, LANC.CDPRODMOVIEST, LANC.DTLANCMOVIEST, LANC.NRLANCMOVIEST, LANC.NMPRODUTO, LANC.CDCONTCTBL, LANC.CDCTBLENTRPR, LANC.IDTIPOMOVIEST, LANC.IDTIPOMOVIEST, C.NMCONTCTBL ) IMP LEFT JOIN CONTCTBL C ON IMP.CDCTBLENTRPR = C.CDCONTCTBL AND C.NRORG = :P_NRORG, FILIAL F WHERE IMP.CDFILIMOVIEST = F.CDFILIAL AND F.NRORG = :P_NRORG AND ROUND(VRCUSTPROD, 2) <> 0 ORDER BY IMP.DTLANCMOVIEST, IMP.NRLANCMOVIEST, IMP.CDFILIMOVIEST, IMP.CDCTBLENTRPR, IMP.CDPRODMOVIEST, IMP.CDCONTCTBL";
    private $sql_adqRelatorioSinAj         = "SELECT TO_DATE(:P_DTINICIAL) AS DTINICIAL, TO_DATE(:P_DTFINAL) AS DTFINAL, SUBSTR(:P_DATACONTAB,1, 10) AS DATACONTAB, TO_DATE(:P_DTCONTAB) AS DTCONTAB, SUBSTR(:P_NMTIPOCUSTO, 1, 50) AS NMTIPOCUSTO, LANCAJUSTE.*, C.NMCONTCTBL AS NMCTBLENTRPR, F.NMFILIAL FROM( SELECT C.NMCONTCTBL AS NMCONTCTBL, LANC.CDFILIMOVIEST, LANC.CDCONTCTBL, LANC.CDCTBLENTRPR, SUM(VRCUSTPROD) VRCUSTPROD FROM ( SELECT DECODE(R.QTLANCAMENTO, 0, 0, VRDIFECUST) AS VRCUSTPROD, R.CDFILIMOVIEST, P.CDARVPROD, CONTCTBL_PRODUTO(P.CDPRODUTO, 'A', R.CDFILIMOVIEST) CDCONTCTBL, CONTCTBL_PRODUTO(P.CDPRODUTO, 'E', R.CDFILIMOVIEST) CDCTBLENTRPR FROM ITLANCTOEST A, RELAT_MOVIEST R, FILIAL F, PRODUTO P WHERE F.CDEMPRESA = :P_CDEMPRESA AND A.NRORG = :P_NRORG AND F.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND ((INSTR(:P_CDFILIAL, F.CDFILIAL) > 0) OR ('T' = :P_CDFILIAL)) AND (R.NRRELATMOVI = :P_NRRELATMOVI) AND (A.CDFILIMOVI = R.CDFILIMOVIEST) AND (A.NRLANCESTQ = R.NRLANCMOVIEST) AND (A.NRSEQUITEM = R.NRSEQUMOVIEST) AND (A.CDALMOXARIFE = R.CDALMOXARIRM) AND (A.CDLOCALESTOQ = R.CDLOCALESTRM) AND (A.IDTIPOMOVI = R.IDTIPOMOVIEST) AND (A.IDTIPOMOVI = '1') AND (R.CDPRODMOVIEST = P.CDARVPROD)) LANC, CONTCTBL C WHERE LANC.CDCONTCTBL = C.CDCONTCTBL(+) AND C.NRORG = :P_NRORG GROUP BY C.NMCONTCTBL, LANC.CDFILIMOVIEST, LANC.CDCONTCTBL, LANC.CDCTBLENTRPR ) LANCAJUSTE, CONTCTBL C, FILIAL F WHERE LANCAJUSTE.CDCTBLENTRPR = C.CDCONTCTBL(+) AND C.NRORG = :P_NRORG AND F.NRORG = :P_NRORG AND LANCAJUSTE.CDFILIMOVIEST = F.CDFILIAL AND ROUND(VRCUSTPROD, 2) <> 0 ORDER BY CDFILIMOVIEST, CDCTBLENTRPR, VRCUSTPROD";
    private $sql_adqRelatorioSinImp        = "SELECT TO_DATE(:P_DTINICIAL) AS DTINICIAL, TO_DATE(:P_DTFINAL) AS DTFINAL, SUBSTR(:P_DATACONTAB,1, 10) AS DATACONTAB, TO_DATE(:P_DTCONTAB) AS DTCONTAB, SUBSTR(:P_NMTIPOCUSTO, 1, 50) AS NMTIPOCUSTO, AJ.*, C.NMCONTCTBL AS NMCTBLENTRPR, F.NMFILIAL FROM( SELECT C.NMCONTCTBL AS NMCONTCTBL, LANC.CDFILIMOVIEST, LANC.CDCONTCTBL, LANC.CDCTBLENTRPR, SUM(VRCUSTPROD) VRCUSTPROD FROM ( SELECT DECODE(DECODE(R.QTLANCMOVIEST, 0, R.QTLANCAMENTO, R.QTLANCMOVIEST), 0, 0, VRDIFECUST) AS VRCUSTPROD, R.CDFILIMOVIEST, P.CDARVPROD, CONTCTBL_PRODUTO(P.CDPRODUTO, 'I', R.CDFILIMOVIEST) CDCONTCTBL, CONTCTBL_PRODUTO(P.CDPRODUTO, 'E', R.CDFILIMOVIEST) CDCTBLENTRPR FROM RELAT_MOVIEST R, FILIAL F, PRODUTO P WHERE F.CDEMPRESA = :P_CDEMPRESA AND F.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND ((INSTR(:P_CDFILIAL, F.CDFILIAL) > 0) OR ('T' = :P_CDFILIAL)) AND (R.NRRELATMOVI = :P_NRRELATMOVI) AND (R.CDFILIMOVIEST = F.CDFILIAL) AND (R.IDTIPOMOVIEST = '0') AND (R.CDPRODMOVIEST = P.CDARVPROD)) LANC LEFT JOIN CONTCTBL C ON LANC.CDCONTCTBL = C.CDCONTCTBL GROUP BY C.NMCONTCTBL, LANC.CDFILIMOVIEST, LANC.CDCONTCTBL, LANC.CDCTBLENTRPR ) AJ LEFT JOIN CONTCTBL C ON AJ.CDCTBLENTRPR = C.CDCONTCTBL AND C.NRORG = :P_NRORG, FILIAL F WHERE AJ.CDFILIMOVIEST = F.CDFILIAL AND F.NRORG = :P_NRORG AND ROUND(VRCUSTPROD, 2) <> 0 ORDER BY AJ.CDFILIMOVIEST, CDCTBLENTRPR, VRCUSTPROD";
    private $sql_adqProdSContCtbl          = "SELECT DISTINCT LANC.CDFILIMOVIEST, LANC.CDARVPROD, FORMATA_CDCONTCTBL(LANC.CONTAAJUSTE) CONTAAJUSTE, FORMATA_CDCONTCTBL(LANC.CONTAIMPL) CONTAIMPL, FORMATA_CDCONTCTBL(LANC.CONTAENTRADA) CONTAENTRADA, P.NMPRODUTO FROM( SELECT R.CDFILIMOVIEST, P.CDARVPROD, CONTCTBL_PRODUTO(P.CDPRODUTO, 'A', R.CDFILIMOVIEST) CONTAAJUSTE, CONTCTBL_PRODUTO(P.CDPRODUTO, 'E', R.CDFILIMOVIEST) CONTAENTRADA, CONTCTBL_PRODUTO(P.CDPRODUTO, 'I', R.CDFILIMOVIEST) CONTAIMPL FROM RELAT_MOVIEST R, FILIAL F, PRODUTO P WHERE F.CDEMPRESA = :P_CDEMPRESA AND F.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND ((INSTR(:P_CDFILIAL, F.CDFILIAL) > 0) OR ('T' = :P_CDFILIAL)) AND (R.NRRELATMOVI = :P_NRRELATMOVI) AND (R.CDFILIMOVIEST = F.CDFILIAL) AND (R.IDTIPOMOVIEST = '1') AND (R.CDPRODMOVIEST = P.CDARVPROD)) LANC, PRODUTO P WHERE ((CONTAAJUSTE IS NULL) OR (CONTAENTRADA IS NULL)) AND P.NRORG = :P_NRORG AND LANC.CDARVPROD = P.CDARVPROD AND :P_IDTPLANC = 'A' UNION ALL SELECT DISTINCT LANC.CDFILIMOVIEST, LANC.CDARVPROD, FORMATA_CDCONTCTBL(LANC.CONTAAJUSTE) CONTAAJUSTE, FORMATA_CDCONTCTBL(LANC.CONTAIMPL) CONTAIMPL, FORMATA_CDCONTCTBL(LANC.CONTAENTRADA) CONTAENTRADA, P.NMPRODUTO FROM ( SELECT R.CDFILIMOVIEST, P.CDARVPROD, CONTCTBL_PRODUTO(P.CDPRODUTO, 'A', R.CDFILIMOVIEST) CONTAAJUSTE, CONTCTBL_PRODUTO(P.CDPRODUTO, 'E', R.CDFILIMOVIEST) CONTAENTRADA, CONTCTBL_PRODUTO(P.CDPRODUTO, 'I', R.CDFILIMOVIEST) CONTAIMPL FROM RELAT_MOVIEST R, FILIAL F, PRODUTO P WHERE F.CDEMPRESA = :P_CDEMPRESA AND F.NRORG = :P_NRORG AND P.NRORG = :P_NRORG AND ((INSTR(:P_CDFILIAL, F.CDFILIAL) > 0) OR ('T' = :P_CDFILIAL)) AND (R.NRRELATMOVI = :P_NRRELATMOVI) AND (R.CDFILIMOVIEST = F.CDFILIAL) AND (R.IDTIPOMOVIEST = '0') AND (R.CDPRODMOVIEST = P.CDARVPROD) ) LANC, PRODUTO P WHERE ((CONTAIMPL IS NULL) OR (CONTAENTRADA IS NULL)) AND P.NRORG = :P_NRORG AND LANC.CDARVPROD = P.CDARVPROD AND :P_IDTPLANC = 'I' ORDER BY 1, 2";
    private $sql_adsAtuSaldTransf          = "BEGIN ATUALIZA_SALDO_EST_TRANSF(:P_CDFILIAL, :P_DTINICIAL, :P_DTFINAL); END;";
    private $sql_adqExistLancLote2         = "SELECT I.CDFILIMOVI FROM ITLANCTOEST I, LANCLOTE L WHERE I.CDFILIMOVI = :P_CDFILIMOVI AND I.NRLANCESTQ = :P_NRLANCESTQ AND I.NRORG = :P_NRORG AND L.NRORG = :P_NRORG AND I.CDEMPITCTB = L.CDEMPRESA AND I.CDLOTEITCTB = L.CDLOTE AND I.NRLOTEITCTB = L.NRLANCLOTE AND I.NRSEQITCTB = L.NRSEQLANLOTE";
    private $sql_adqContaContabil          = "SELECT CDCONTCTBL, IDCONTCCUS FROM CONTCTBL WHERE NRORG = :P_NRORG AND (CDCONTCTBL = :P_CDCONTCTBL OR :P_CDCONTCTBL IS NULL)";
    private $sql_adqLancLote               = "SELECT NRSEQLANLOTE FROM LANCLOTE WHERE CDEMPRESA = :P_CDEMPRESA AND CDLOTE = :P_CDLOTE AND NRLANCLOTE = :P_NRLANCLOTE AND CDCONTCTBL = :P_CDCONTCTBL AND NRORG = :P_NRORG";
    private $sql_acmUpdateLancLote         = "UPDATE LANCLOTE SET VRLANCLOTE = VRLANCLOTE + :P_VRLANCLOTE WHERE CDEMPRESA = :P_CDEMPRESA AND CDLOTE = :P_CDLOTE AND NRLANCLOTE = :P_NRLANCLOTE AND CDCONTCTBL = :P_CDCONTCTBL AND NRORG = :P_NRORG";
    private $sql_adqRateCCus               = "SELECT R.NRSEQLANLOTE, R.NRLANCLOTE FROM LANCLOTE L, RATECCUS R WHERE L.CDEMPRESA = :P_CDEMPRESA AND L.CDLOTE = :P_CDLOTE AND L.NRLANCLOTE = :P_NRLANCLOTE AND L.CDCONTCTBL = :P_CDCONTCTBL AND L.CDEMPRESA = R.CDEMPRESA AND L.CDLOTE = R.CDLOTE AND L.NRLANCLOTE = R.NRLANCLOTE AND L.NRSEQLANLOTE = R.NRSEQLANLOTE AND R.CDFILIAL = :P_CDFILIAL AND R.CDCENTCUST = :P_CDCENTCUST AND L.NRORG = :P_NRORG";
    private $sql_acmUpdateRateCCus         = "UPDATE RATECCUS SET VRRATECCUS = VRRATECCUS + :P_VRRATECCUS WHERE CDEMPRESA = :P_CDEMPRESA AND CDLOTE = :P_CDLOTE AND NRLANCLOTE = :P_NRLANCLOTE AND NRSEQLANLOTE = :P_NRSEQLANLOTE AND CDFILIAL = :P_CDFILIAL AND CDCENTCUST = :P_CDCENTCUST AND NRORG = :P_NRORG";
    private $sql_acmUpdateItLancto2        = "UPDATE ITLANCTOEST SET CDEMPITCTB = :P_CDEMPRESA, CDLOTEITCTB = :P_CDLOTE, NRLOTEITCTB = :P_NRLANCLOTE, NRSEQITCTB = :P_NRSEQLANLOTE WHERE CDFILIMOVI = :P_CDFILIMOVI AND NRLANCESTQ = :P_NRLANCESTQ AND NRORG = :P_NRORG";
    
    private $adqExisteLote                 = "SELECT CDLOTE FROM CAPALOTE WHERE CDLOTE = :P_CDLOTE AND CDEMPRESA = :P_CDEMPRESA";
    private $adqVerificaPeriodoCtb         = "SELECT DTINICLANC, DTFINALANC FROM CONTOPECTBL WHERE CDEMPRESA = :P_CDEMPRESA AND DTINICLANC <= :P_DTINICIAL AND DTFINALANC >= :P_DTFINAL";
    private $acmDelCtbTemp                 = "DELETE FROM CTB_TEMP_CREDPRES WHERE CDINSCESTA = :P_CDINSCESTA";

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();
        
        //Inicia a conexão
        $this->entityManager->beginTransaction();
    }
    
    /*Realiza o commit*/
    public function commit() {
        $this->entityManager->commit();
    }
    
    /*Realiza o rollback*/
    public function rollback() {
        $this->entityManager->rollback();
    }

    /*Se o parâmetro for um array este converte para valores separados por ',', caso contrário retorna o próprio parâmetro*/
    public function arrayToString($array) {
        return is_array($array) ? implode(",", $array) : $array;
    }
    
    /*Funções para o cdsResult*/
    public function adqContOpeCtbl($cdfilial, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDFILIAL"  => $this->arrayToString($cdfilial),
            "P_CDEMPRESA" => $cdempresa,
            "P_NRORG"     => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqContOpeCtbl); //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqGeraLote($cdfilial, $cdtiporeti, $dtinicial, $dtfinal, $dtcontab, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDFILIAL"   => $this->arrayToString($cdfilial),
            "P_CDTIPORETI" => $this->arrayToString($cdtiporeti),
            "P_DTINICIAL"  => $dtinicial,
            "P_DTFINAL"    => $dtfinal,
            "P_DTCONTAB"   => $dtcontab,
            "P_CDEMPRESA"  => $cdempresa,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqGeraLote);    //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqGeraLoteDtMovi($cdfilial, $cdtiporeti, $dtinicial, $dtfinal, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDFILIAL"   => $this->arrayToString($cdfilial),
            "P_CDTIPORETI" => $this->arrayToString($cdtiporeti),
            "P_DTINICIAL"  => $dtinicial,
            "P_DTFINAL"    => $dtfinal,
            "P_CDEMPRESA"  => $cdempresa,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqGeraLoteDtMovi);  //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                          //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqGeraLoteCustLanc($cdfilial, $cdtiporeti, $dtinicial, $dtfinal, $dtcontab, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDFILIAL"   => $this->arrayToString($cdfilial),
            "P_CDTIPORETI" => $this->arrayToString($cdtiporeti),
            "P_DTINICIAL"  => $dtinicial,
            "P_DTFINAL"    => $dtfinal,
            "P_DTCONTAB"   => $dtcontab,
            "P_CDEMPRESA"  => $cdempresa,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqGeraLoteCustLanc);    //Prepara o statement da query para execução.
        $statement->execute($params);                                               //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                              //Executa um fetch em todos os dados, retornando-os.
    }

    public function adqGeraLoteCustLancDtMovi($cdfilial, $cdtiporeti, $dtinicial, $dtfinal, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDFILIAL"   => $this->arrayToString($cdfilial),
            "P_CDTIPORETI" => $this->arrayToString($cdtiporeti),
            "P_DTINICIAL"  => $dtinicial,
            "P_DTFINAL"    => $dtfinal,
            "P_CDEMPRESA"  => $cdempresa,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqGeraLoteCustLancDtMovi);  //Prepara o statement da query para execução.
        $statement->execute($params);                                                   //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                                  //Executa um fetch em todos os dados, retornando-os.
    }
    
    /*Funções 'pós cdsResult'*/
    public function adqVerLote($cdempresa, $cdlote, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDLOTE"     => $cdlote,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqVerLote);  //Prepara o statement da query para execução.
        $statement->execute($params);                                    //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                   //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqExistLancLote($cdempresa, $cdlote, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDLOTE"     => $cdlote,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_ExistLancLote);  //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function acmCapaLote($cdlote, $cdempresa, $dsobselote, $idlote, $dtiniclote, $dtfinalote, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"     => $nrorg,
            "P_CDLOTE"    => $cdlote,
            "P_CDEMPRESA" => $cdempresa,
            "P_DSOBSELOTE"=> $dsobselote,
            "P_IDLOTE"    => $idlote,
            "P_DTINICLOTE"=> $dtiniclote,
            "P_DTFINALOTE"=> $dtfinalote
        );
        $statement = $this->connection->prepare($this->sql_acmCapaLote);    //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
    }
    
    public function acmLancLote($cdempresa, $cdlote, $nrlanclote, $nrseqlanlote, $cdcontctbl, $cdhistpadr, $dtlanclote, $nrdoculote, $dshistlote, $vrlanclote, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"       => $nrorg,
            "P_CDEMPRESA"   => $cdempresa,
            "P_CDLOTE"      => $cdlote,
            "P_NRLANCLOTE"  => $nrlanclote,
            "P_NRSEQLANLOTE"=> $nrseqlanlote,
            "P_CDCONTCTBL"  => $cdcontctbl,
            "P_CDHISTPADR"  => $cdhistpadr,
            "P_DTLANCLOTE"  => $dtlanclote,
            "P_NRDOCULOTE"  => $nrdoculote,
            "P_DSHISTLOTE"  => $dshistlote,
            "P_VRLANCLOTE"  => $vrlanclote
        );
        $statement = $this->connection->prepare($this->sql_acmLancLote);    //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
    }
    
    public function adqContCtbl($cdcontctbl, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDCONTCTBL"=> $cdcontctbl,
            "P_NRORG"     => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqContCtbl);    //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function acmRatCusto($cdempresa, $cdlote, $nrlanclote, $nrseqlanlote, $cdfilial, $cdcentcust, $dtcomprateccus, $vrrateccus, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"         => $nrorg,
            "P_CDEMPRESA"     => $cdempresa,
            "P_CDLOTE"        => $cdlote,
            "P_NRLANCLOTE"    => $nrlanclote,
            "P_NRSEQLANLOTE"  => $nrseqlanlote,
            "P_CDFILIAL"      => $cdfilial,
            "P_CDCENTCUST"    => $cdcentcust,
            "P_DTCOMPRATECCUS"=> $dtcomprateccus,
            "P_VRRATECCUS"    => $vrrateccus);
        $statement = $this->connection->prepare($this->sql_acmRatCusto);    //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
    }
    
    public function adqProdSemCContabil($cdfilial, $cdtiporeti, $dtinicial, $dtfinal, $dtcontab, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"      => $nrorg,
            "P_CDFILIAL"   => $this->arrayToString($cdfilial),
            "P_CDTIPORETI" => $this->arrayToString($cdtiporeti),
            "P_DTINICIAL"  => $dtinicial,
            "P_DTFINAL"    => $dtfinal,
            "P_DTCONTAB"   => $dtcontab
        );
        $statement = $this->connection->prepare($this->sql_adqProdSemCContabil);    //Prepara o statement da query para execução.
        $statement->execute($params);                                               //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                              //Executa um fetch em todos os dados, retornando-os.
    }

    public function acmUpdateItLancto($cdfilial, $cdtiporeti, $cdempresa, $cdlote, $dtinicial, $dtfinal, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"         => $nrorg,
            "P_CDFILIAL"      => $this->arrayToString($cdfilial),
            "P_CDTIPORETI"    => $this->arrayToString($cdtiporeti),
            "P_CDEMPRESA"     => $cdempresa,
            "P_CDLOTE"        => $cdlote,
            "P_DTINICIAL"     => $dtinicial,
            "P_DTFINAL"       => $dtfinal);
        $statement = $this->connection->prepare($this->sql_acmUpdateItLancto);  //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os parâmetros passados.
    }
    
    /*Funções para Apropriação Contábil Implantações*/
    public function qryFiliaisEmpr($cdempresa, $cdfilial, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"      => $nrorg,
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDFILIAL"   => $this->arrayToString($cdfilial)
        );
        $statement = $this->connection->prepare($this->sql_qryFiliaisEmpr); //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqCodProd($nrorg) {
        $params = array(    //Parâmetro da query
            "P_NRORG"      => $nrorg,
        );
        $statement = $this->connection->prepare($this->sql_adqCodProd); //Prepara o statement da query para execução.
        $statement->execute($params);                                   //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();  
    }
    
    public function adqFiliaisEmpr($cdempresa, $cdfilial, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"      => $nrorg,
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDFILIAL"   => $this->arrayToString($cdfilial)
        );
        $statement = $this->connection->prepare($this->sql_qryFiliaisEmpr); //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adsMovi_EstoqueORA($filial, $cdalmoxarife, $cdlocalestoq, $nrloteestq, $tamnivel, $dtinicial, $dtfinal, $prodini, $prodfim, $idlancto, $idcusto, $sequmovi, $movconsolid, $delmovimen, $nrorg) {
        $params = array(    //Parâmetros da query
            //"P_NRORG"        => $nrorg,
            "P_FILIAL"       => $filial,
            "P_CDALMOXARIFE" => $cdalmoxarife,
            "P_CDLOCALESTOQ" => $cdlocalestoq,
            "P_NRLOTEESTQ"   => $nrloteestq,
            "P_TAMNIVEL"     => $tamnivel,
            "P_DTINICIAL"    => $dtinicial,
            "P_DTFINAL"      => $dtfinal,
            "P_PRODINI"      => $prodini,
            "P_PRODFIM"      => $prodfim,
            "P_IDLANCTO"     => $idlancto,
            "P_IDCUSTO"      => $idcusto,
            "P_SEQUMOVI"     => $sequmovi,
            "P_MOVCONSOLID"  => $movconsolid,
            "P_DELMOVIMEN"   => $delmovimen
        );

        $statement = $this->connection->prepare($this->sql_adsMovi_EstoqueORA); //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os paràmetros passados.
    }
    
    public function adqGeraLote2($cdfilial, $nrrelatmovi, $idtplanc, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"       => $nrorg,
            "P_CDFILIAL"    => $this->arrayToString($cdfilial),
            "P_NRRELATMOVI" => $nrrelatmovi,
            "P_IDTPLANC"    => $idtplanc,
            "P_CDEMPRESA"   => $cdempresa
        );

        $statement = $this->connection->prepare($this->sql_adqGeraLote2);   //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqRelatorioAnalAj($dtinicial, $dtfinal, $datacontab, $dtcontab, $nmtipocusto, $nrrelatmovi, $cdfilial, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"       => $nrorg,
            "P_DTINICIAL"   => $dtinicial,
            "P_DTFINAL"     => $dtfinal,
            "P_DATACONTAB"  => $datacontab,
            "P_DTCONTAB"    => $dtcontab,
            "P_NMTIPOCUSTO" => $nmtipocusto,
            "P_NRRELATMOVI" => $nrrelatmovi,
            "P_CDFILIAL"    => $this->arrayToString($cdfilial),
            "P_CDEMPRESA"   => $cdempresa
        );
        $statement = $this->connection->prepare($this->sql_adqRelatorioAnalAj); //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                          //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqRelatorioAnalImp($dtinicial, $dtfinal, $datacontab, $dtcontab, $nmtipocusto, $nrrelatmovi, $cdfilial, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"       => $nrorg,
            "P_DTINICIAL"   => $dtinicial,
            "P_DTFINAL"     => $dtfinal,
            "P_DATACONTAB"  => $datacontab,
            "P_DTCONTAB"    => $dtcontab,
            "P_NMTIPOCUSTO" => $nmtipocusto,
            "P_NRRELATMOVI" => $nrrelatmovi,
            "P_CDFILIAL"    => $this->arrayToString($cdfilial),
            "P_CDEMPRESA"   => $cdempresa
        );
        $statement = $this->connection->prepare($this->sql_adqRelatorioAnalImp);    //Prepara o statement da query para execução.
        $statement->execute($params);                                               //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                              //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqRelatorioSinAj($dtinicial, $dtfinal, $datacontab, $dtcontab, $nmtipocusto, $nrrelatmovi, $cdfilial, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"       => $nrorg,
            "P_DTINICIAL"   => $dtinicial,
            "P_DTFINAL"     => $dtfinal,
            "P_DATACONTAB"  => $datacontab,
            "P_DTCONTAB"    => $dtcontab,
            "P_NMTIPOCUSTO" => $nmtipocusto,
            "P_NRRELATMOVI" => $nrrelatmovi,
            "P_CDFILIAL"    => $this->arrayToString($cdfilial),
            "P_CDEMPRESA"   => $cdempresa
        );
        $statement = $this->connection->prepare($this->sql_adqRelatorioSinAj);  //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                          //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqRelatorioSinImp($dtinicial, $dtfinal, $datacontab, $dtcontab, $nmtipocusto, $nrrelatmovi, $cdfilial, $cdempresa, $nrorg)  {
        $params = array(    //Parâmetros da query
            "P_NRORG"       => $nrorg,
            "P_DTINICIAL"   => $dtinicial,
            "P_DTFINAL"     => $dtfinal,
            "P_DATACONTAB"  => $datacontab,
            "P_DTCONTAB"    => $dtcontab,
            "P_NMTIPOCUSTO" => $nmtipocusto,
            "P_NRRELATMOVI" => $nrrelatmovi,
            "P_CDFILIAL"    => $this->arrayToString($cdfilial),
            "P_CDEMPRESA"   => $cdempresa
        );
        $statement = $this->connection->prepare($this->sql_adqRelatorioSinImp); //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                          //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqProdSContCtbl($cdfilial, $nrrelatmovi, $idtplanc, $cdempresa, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"       => $nrorg,
            "P_CDFILIAL"    => $this->arrayToString($cdfilial),
            "P_NRRELATMOVI" => $nrrelatmovi,
            "P_IDTPLANC"    => $idtplanc,
            "P_CDEMPRESA"   => $cdempresa
        );
        $statement = $this->connection->prepare($this->sql_adqProdSContCtbl);   //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                          //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adsAtuSaldTransf($cdfilial, $dtinicial, $dtfinal) {
        $params = array(    //Parâmetros da query
            "P_CDFILIAL"  => $this->arrayToString($cdfilial),
            "P_DTINICIAL" => $dtinicial,
            "P_DTFINAL"   => $dtfinal
        );

        $statement = $this->connection->prepare($this->sql_adsAtuSaldTransf);   //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os paràmetros passados.
    }
    
    public function adqExistLancLote2($nrlancestq, $cdfilimovi, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRLANCESTQ" => $nrlancestq,
            "P_CDFILIMOVI" => $cdfilimovi,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqExistLancLote2);  //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os paràmetros passados.
        return $statement->fetchAll();                                          //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqContaContabil($cdcontctbl, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDCONTCTBL" => $cdcontctbl,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqContaContabil);   //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os parâmetros passados.
        return $statement->fetchAll();                                          //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function adqLancLote($cdlote, $cdcontctbl, $cdempresa, $nrlanclote, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDLOTE"     => $cdlote,
            "P_CDCONTCTBL" => $cdcontctbl,
            "P_CDEMPRESA"  => $cdempresa,
            "P_NRLANCLOTE" => $nrlanclote,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqLancLote);    //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os parâmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function acmUpdateLancLote($vrlanclote, $cdempresa, $cdlote, $nrlanclote, $cdcontctbl, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"      => $nrorg,
            "P_VRLANCLOTE" => $vrlanclote,
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDLOTE"     => $cdlote,
            "P_NRLANCLOTE" => $nrlanclote,
            "P_CDCONTCTBL" => $cdcontctbl);
        $statement = $this->connection->prepare($this->sql_acmUpdateLancLote);  //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os parâmetros passados.
    }
    
    public function adqRateCCus($cdempresa, $cdlote, $nrlanclote, $cdcontctbl, $cdfilial, $cdcentcust, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDLOTE"     => $cdlote,
            "P_NRLANCLOTE" => $nrlanclote,
            "P_CDCONTCTBL" => $cdcontctbl,
            "P_CDFILIAL"   => $cdfilial,
            "P_CDCENTCUST" => $cdcentcust,
            "P_NRORG"      => $nrorg
        );
        $statement = $this->connection->prepare($this->sql_adqRateCCus);    //Prepara o statement da query para execução.
        $statement->execute($params);                                       //Executa o statement com os parâmetros passados.
        return $statement->fetchAll();                                      //Executa um fetch em todos os dados, retornando-os.
    }
    
    public function acmUpdateRateCCus($vrrateccus, $cdempresa, $cdlote, $nrlanclote, $cdfilial, $cdcentcust, $nrseqlanlote, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"        => $nrorg,
            "P_VRRATECCUS"   => $vrrateccus,
            "P_CDEMPRESA"    => $cdempresa,
            "P_CDLOTE"       => $cdlote,
            "P_NRLANCLOTE"   => $nrlanclote,
            "P_CDFILIAL"     => $cdfilial,
            "P_CDCENTCUST"   => $cdcentcust,
            "P_NRSEQLANLOTE" => $nrseqlanlote);
        $statement = $this->connection->prepare($this->sql_acmUpdateRateCCus);  //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os parâmetros passados.
    }
    
    public function acmUpdateItLancto2($cdempresa, $cdlote, $nrlanclote, $nrseqlanlote, $nrlancestq, $cdfilimovi, $nrorg) {
        $params = array(    //Parâmetros da query
            "P_NRORG"        => $nrorg,
            "P_CDEMPRESA"    => $cdempresa,
            "P_CDLOTE"       => $cdlote,
            "P_NRLANCLOTE"   => $nrlanclote,
            "P_NRSEQLANLOTE" => $nrseqlanlote,
            "P_NRLANCESTQ"   => $nrlancestq,
            "P_CDFILIMOVI"   => $cdfilimovi
            );
        $statement = $this->connection->prepare($this->sql_acmUpdateItLancto2);  //Prepara o statement da query para execução.
        $statement->execute($params);                                           //Executa o statement com os parâmetros passados.
    }
    
    public function verificaCdlote($row) {
        $params = array(    //Parâmetros da query
            "P_CDLOTE"   => $row['CDLOTE'],
            "P_CDEMPRESA"    => $row['CDEMPRESA']
        );
        $statement = $this->connection->prepare($this->adqExisteLote);  //Prepara o statement da query para execução.
        $statement->execute($params);                                   //Executa o statement com os parâmetros passados.
        return $statement->fetch();
    }
    
    public function verificaPeriodoCtb($row) {
        $params = array(    //Parâmetros da query
            "P_CDEMPRESA"    => $row['CDEMPRESA'],
            "P_DTINICIAL"    => $row['DTINICIAL'],
            "P_DTFINAL"    => $row['DTFINAL']
        );
        $statement = $this->connection->prepare($this->adqVerificaPeriodoCtb);  //Prepara o statement da query para execução.
        $statement->execute($params);                                   //Executa o statement com os parâmetros passados.
        return $statement->fetch();
    }
    
    public function deletaRelatorioInsc($row) {
        $params = array(    //Parâmetros da query
            "P_CDINSCESTA"    => $row['CDINSCESTA']
            );
        $statement = $this->connection->prepare($this->acmDelCtbTemp);  //Prepara o statement da query para execução.
        $statement->execute($params);                                   //Executa o statement com os parâmetros passados.
    }
    
    public function contabilizaImp($row) {
        $procedure = new StoredProcedure($this->connection, 'CTB_IMPOSTO_DIFERENCIADO');

        $procedure->addParam(new Param('P_CDFILIAL',    Param::PARAM_INPUT, NULL, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDINSCESTA',  Param::PARAM_INPUT, $row['CDINSCESTA'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL',   Param::PARAM_INPUT, $row['DTINICIAL'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL',     Param::PARAM_INPUT, $row['DTFINAL'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDEMPRESA',   Param::PARAM_INPUT, $row['CDEMPRESA'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDHISTPADR',  Param::PARAM_INPUT, $row['CDHISTPADR'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDLOTE',      Param::PARAM_INPUT, $row['CDLOTE'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TIPO',        Param::PARAM_INPUT, $row['TIPO'], Param::PARAM_TYPE_STR));
        
        $procedure->execute();
        
        //$this->commit();
    }
    
    public function ctbAjusteApuracao($row) {
        
        $procedure = new StoredProcedure($this->connection, 'CTB_AJUSTE_APURACAO');

        $procedure->addParam(new Param('P_CDIMPOSTO',       Param::PARAM_INPUT, $row['CDIMPOSTONFE'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDEMPRESA',       Param::PARAM_INPUT, $row['CDEMPRESA'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDINSCESTA',      Param::PARAM_INPUT, $row['CDINSCESTA'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDINSCMUNI',      Param::PARAM_INPUT, $row['CDINSCMUNI'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQUMAPAPU',    Param::PARAM_INPUT, $row['NRSEQUMAPAPU'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDTABELA',        Param::PARAM_INPUT, $row['IDTABELA'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDTPAJUSTE',      Param::PARAM_INPUT, $row['IDTPAJUSTE'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQITEM',       Param::PARAM_INPUT, $row['NRSEQAJUSTE'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDLOTE',          Param::PARAM_INPUT, $row['CDLOTE'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDHISTPADR',      Param::PARAM_INPUT, $row['CDHISTPADR'], Param::PARAM_TYPE_STR));
        
        
        $procedure->execute();

        //$this->commit();
    }
    
    public function selectCtbTemp($row){
        $sql = "SELECT CDFILIAL, TO_CHAR(TO_NUMBER(NRNOTAFISC)) AS NRNOTAFISC,VRTOTENTRADAS, VRTOTSAIDAS, VRCREDPRES, VRGLP, VRSAIDCONTAB, CDCONTCTBLDEB, CDCONTCTBLCRED, DSHISTORICO
                  FROM CTB_TEMP_CREDPRES
                 WHERE CDINSCESTA = :P_CDINSCESTA";
        $params = array(    //Parâmetros da query
            "P_CDINSCESTA"    => $row['CDINSCESTA']
            );
        $statement = $this->connection->prepare($sql);  //Prepara o statement da query para execução.
        $statement->execute($params);                                   //Executa o statement com os parâmetros passados.
        //var_dump($statement->fetchAll());
    }

}