<?php
namespace Teknisa\CTB\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ctb89000PreValidacaoEcdFactory {
    
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function executaProcedure(
        $cdempresa, $ano
    ){
        $procedure = new StoredProcedure($this->entityManager->getConnection(), 'PRE_VALIDACAO_ECD');
        $procedure->addParam(new Param('P_CDEMPRESA'    , Param::PARAM_INPUT , $cdempresa    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ANO'  , Param::PARAM_INPUT , $ano  , Param::PARAM_TYPE_STR));
        $preValidacao = $procedure->execute();
        
        return $preValidacao;
    }
    
    
}