<?php

namespace Teknisa\CTB\Services;

use Teknisa\CTB\Factories\Ctb6900RelatorioAcompanhamentoOrFactory;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Teknisa\Model\Contabilidade\Entities\Contopectbl;
use Teknisa\Model\Contabilidade\Entities\Lancccusto;
use Teknisa\Model\Contabilidade\Entities\Lanclote;
use Teknisa\Model\Contabilidade\Entities\Lanccont;
use Teknisa\Model\Geral\Entities\Centcustfil;
use Teknisa\Model\Geral\Entities\Contctbl;
use Teknisa\Model\Geral\Entities\Filial;

class Ctb6900RelatorioAcompanhamentoOrCSerice {

    protected $entityManager;
    protected $environment;
    protected $lancamentosFactory;
    protected $newCode;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Environment $environment, Ctb6900RelatorioAcompanhamentoOrFactory $Ctb6900RelatorioAcompanhamentoOrFactory, NewCode $newCode) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->Ctb6900RelatorioAcompanhamentoOrFactory = $Ctb6900RelatorioAcompanhamentoOrFactory;
        $this->newCode = $newCode;
    }

    public function execProcGERA_REL_ACOMPANHAMENTO_ORCA($row) {
        try{
            
            $cdempresa = implode(',', $row["CDEMPRESA"]);
            $cddemons = $row["CDTIPODEMO"];
            $empresaorca =  $row["EMPRESAORCAMENT"];
            $cdorca =  $row["CDORCAMENT"];
            $cdfilial =  implode(',', $row["CDFILIAL"]);
            $cdcentcust = implode(',', $row["CDCENTCUST"]);
            $cdcontini  = $row["CDCONTCTBLINI"];
            $cdcontfim  =  $row["CDCONTCTBLFIN"];
            $dtinicial = $row["DTINICIAL"];
            $dtFinal = $row["DTFINAL"];
            
            // Convertendo para o formato completo (YYYY-MM-DD)
            $dtinicial = date('Y-m-d', strtotime('01-' . str_replace('/', '-', $row["DTINICIAL"])));
            
            // Convertendo para o formato completo (YYYY-MM-DD)
            $primeiro_ultimo_dia = date('Y-m-d', strtotime('01-' . str_replace('/', '-', $row["DTFINAL"])));
            
            // Primeiro dia do mês
            $primeiro_dia = date('d/m/Y', strtotime($dtinicial));
            
            // Ultimo dia do mês
            $ultimo_dia = date('t/m/Y', strtotime($primeiro_ultimo_dia));
            
            $visualizadre = $row["VISUALIZADRE"];
            $relatorio =  $row["REPORT_CODE"];
            $nivel = $row["CDNVCONT"];
  
            $balancete = $this->Ctb6900RelatorioAcompanhamentoOrFactory->execProcGERA_REL_ACOMPANHAMENTO_ORCA(
                $cdempresa,$cddemons, $empresaorca, $cdorca, $cdfilial, $cdcentcust,$cdcontini,
                $cdcontfim, $primeiro_dia,$ultimo_dia,$visualizadre, $relatorio, $nivel
            );
        } catch (\Exception $e) {
            throw $e;
        }
        return $balancete;
    }
    
    
}