<?php
namespace Teknisa\CTB\Services;

use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Teknisa\CTB\Factories\Ctb93000EscrituracaoContabilFiscalFactory;

class Ctb93000EscrituracaoContabilFiscalService {

    protected $entityManager;
    protected $environment;
    protected $newCode;
    protected $ctb93000EscrituracaoContabilFiscalFactory;

    public function __construct(EntityManager $entityManager, Environment $environment, NewCode $newCode, Ctb93000EscrituracaoContabilFiscalFactory $ctb93000EscrituracaoContabilFiscalFactory)
    {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->newCode  = $newCode;
        $this->ctb93000EscrituracaoContabilFiscalFactory  = $ctb93000EscrituracaoContabilFiscalFactory;
    }

    public function donwloadArquivo($arquivo)
    {
        try{
            if(isset($arquivo) && file_exists($arquivo)){
                $tipo = null;

                switch(strtolower(substr(strrchr(basename($arquivo),"."),1))){
                    case "gif" : $tipo="image/gif"                    ; break;
                    case "png" : $tipo="image/png"                    ; break;
                    case "jpg" : $tipo="image/jpg"                    ; break;
                    case "wma" : $tipo="audio/mime"                   ; break;
                    case "txt" : $tipo="text/plain"                   ; break;
                    case "rem" : $tipo="text/plain"                   ; break;
                    case "mp3" : $tipo="audio/mpeg"                   ; break;
                    case "mp4" : $tipo="video/mpeg-4"                 ; break;
                    case "pdf" : $tipo="application/pdf"              ; break;
                    case "zip" : $tipo="application/zip"              ; break;
                    case "doc" : $tipo="application/msword"           ; break;
                    case "xls" : $tipo="application/vnd.ms-excel"     ; break;
                    case "exe" : $tipo="application/octet-stream"     ; break;
                    case "ppt" : $tipo="application/vnd.ms-powerpoint"; break;
                    case "php" :                                      ; break;
                    case "htm" :                                      ; break;
                    case "html":                                      ; break;
                    break;
                }

                header("Content-Type: ".$tipo);
                header("Content-Length: ".filesize($arquivo));
                header("Content-Disposition: attachment; filename=".basename($arquivo));
                
                readfile($arquivo);
                unlink($arquivo);

                die();
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function exportaECF($cdempresa, $dtanoref, $idecfretifi, $idecftransmi, $nrrecibo, $row){
        try {
            
            $nrorg       = $this->environment->getNrOrgTrab();
            $nrseqarqmag = $this->newCode->getCodeByTableName('ARQMAGNETICO', $nrorg, 1, 10);

            $this->ctb93000EscrituracaoContabilFiscalFactory->exportaECF(
                $cdempresa, $dtanoref, $idecfretifi, $idecftransmi, $nrrecibo, $nrseqarqmag
            );
            
            $selectArqMag = $this->ctb93000EscrituracaoContabilFiscalFactory->exportaECF(
                $cdempresa, $dtanoref, $idecfretifi, $idecftransmi, $nrrecibo, $nrseqarqmag
            );
            
            $arqmag_array = $this->ctb93000EscrituracaoContabilFiscalFactory->selectArqMag($nrseqarqmag);
            $caminhoArquivo = '/tmp/'.$row["NMARQUIVO"];
            $file = fopen($caminhoArquivo.'.txt', "a+");
            
            if (strpos($row["NMARQUIVO"], '../') !== false){
                die("ERRO");
            }
            
            
            foreach ($arqmag_array as $row) {
                
                fprintf($file, "%s", $row['DSREGARQMAG']);
                fprintf($file, "\n");
                
            }
            
            fclose($file);
            
            return ($caminhoArquivo.'.txt');
            
        } catch (\Exception $e) {
            throw $e;
        }
    }
    

}