<?php
namespace Teknisa\CTB\Services;

use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;
use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Environment;

class ctb53100DemonstracoesContabeisService  {

	protected $demostracaoFactory;
    protected $entityManager;
    protected $nrorg;
    protected $environment;
    protected $newCode;
    
    public function __construct($entityManager, $demostracaoFactory, Environment $environment, NewCode $newCode) {
        $this->entityManager = $entityManager;
        $this->demostracaoFactory = $demostracaoFactory;
        $this->environment = $environment;
        $this->nrorg         = $environment->getNrOrgTrab();
        $this->newCode = $newCode;
 	}
 	
 	public function callProcedureDemonstrativoCTBO ($row){
 	  //Busca Novo Codigo para DEMOCTBOFICIAL
 	  $nrctbtemp = $this->newCode->getCodeByTableName('DEMOCTBOFICIAL', $this->nrorg);

 	  $row['NRDEMO'] = intval($nrctbtemp);
      
 	  return $this->demostracaoFactory->callProcedureDemonstrativoCTBO($row);
 	}
 	
 	public function montaRelatorio($reportName, $row){
 	    $parameterRow = array();

        $parameterRow["CDTIPODEMO"] = $row["CDTIPODEMO"];
        $parameterRow["IDDESCENCER"] = $row["IDDESCENCER"];
        $parameterRow["DATAB"] = $row["DATAB"]; 
        $parameterRow["DATAA"] = $row["DATAA"]; 
        $parameterRow["IDSALDO"] = $row["IDSALDO"]; 
        $parameterRow["CDEMPRESA"] = $row["CDEMPRESA"];
        $parameterRow["NMEMPRESA"]  = $row["NMEMPRESA"];
        $parameterRow["NRINSJUREMPR"] = $row["NRINSJUREMPR"];
        $parameterRow["EMPRESAUNICA"] = $row["EMPRESAUNICA"];
        $parameterRow["DATABINTERB"] = $row["DATABINTERB"];
        $parameterRow["DATABINTERA"] = $row["DATABINTERA"];
        $parameterRow["DATAASS"] =  $row["DATAASS"];
        $parameterRow["NRDEMO"] =  $row["NRDEMO"];
        $parameterRow["NMTIPODEMO"] =  $row["NMTIPODEMO"];
        $parameterRow["DATAAINTERA"] =  $row["DATAAINTERA"];
        $parameterRow["SHOWITEMZERA"] =  $row["SHOWITEMZERA"];
        $parameterRow["__format"] =  $row["FORMAT"];

        return $this->demostracaoFactory->montaRelatorio($reportName, $parameterRow);
    }
 	
}