/* Tabela RETIRADA: Retirada */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RETIRADA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Retirada,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_RETIRADA
AFTER DELETE OR INSERT OR UPDATE
ON RETIRADA FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
      V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO;
      V_DESC := V_DESC || ' Reti=' || :OLD.NRRETIRADA;
      V_DESC := V_DESC || ' DataReti=' || :OLD.DTRETIRADA;
      IF (NVL(:OLD.NRREQUEXTRRE, '') <> '') THEN
         V_DESC := V_DESC || ' RequExt=' || :OLD.NRREQUEXTRRE;
      END IF;
      IF (NVL(:OLD.CDFILANCESTQ, '') <> '') THEN
         V_DESC := V_DESC || ' FiliEst=' || :OLD.CDFILANCESTQ;
      END IF;
      IF (NVL(:OLD.NRLANCESTQ, '') <> '') THEN
         V_DESC := V_DESC || ' Lanto=' || :OLD.NRLANCESTQ;
      END IF;
      IF (NVL(:OLD.IDRETIPRAT, '') <> '') THEN
         V_DESC := V_DESC || ' RetiPrat=' || :OLD.IDRETIPRAT;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL||:OLD.NRRETIRADA||TO_CHAR(:OLD.DTRETIRADA, 'YYYYMMDD')||:OLD.NRLANCESTQ;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL   <> :NEW.CDFILIAL  ) OR
            (:OLD.NRCARDAPIO <> :NEW.NRCARDAPIO) OR
            (:OLD.NRRETIRADA <> :NEW.NRRETIRADA) OR
            (:OLD.DTRETIRADA <> :NEW.DTRETIRADA) OR
            (NVL(:OLD.NRREQUEXTRRE, '') <> NVL(:NEW.NRREQUEXTRRE, '')) OR
            (NVL(:OLD.CDFILANCESTQ, '') <> NVL(:NEW.CDFILANCESTQ, '')) OR
            (NVL(:OLD.NRLANCESTQ,   '') <> NVL(:NEW.NRLANCESTQ,   '')) OR
            (NVL(:OLD.IDRETIPRAT,   '') <> NVL(:NEW.IDRETIPRAT,   '')) THEN
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL||:OLD.NRRETIRADA||TO_CHAR(:OLD.DTRETIRADA, 'YYYYMMDD')||:OLD.NRLANCESTQ;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL||:NEW.NRRETIRADA||TO_CHAR(:NEW.DTRETIRADA, 'YYYYMMDD')||:NEW.NRLANCESTQ;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDFILIAL <> :NEW.CDFILIAL) THEN
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
         ELSE
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Fili=' || :NEW.CDFILIAL;
      END IF;
      IF UPDATING THEN
         IF (:OLD.NRCARDAPIO <> :NEW.NRCARDAPIO) THEN
            V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO || '|' || :NEW.NRCARDAPIO;
         ELSE
            V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Card=' || :NEW.NRCARDAPIO;
      END IF;
      IF UPDATING THEN
         IF (:OLD.NRRETIRADA <> :NEW.NRRETIRADA) THEN
            V_DESC := V_DESC || ' Reti=' || :OLD.NRRETIRADA || '|' || :NEW.NRRETIRADA;
         ELSE
            V_DESC := V_DESC || ' Reti=' || :OLD.NRRETIRADA;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Reti=' || :NEW.NRRETIRADA;
      END IF;
      IF UPDATING THEN
         IF (:OLD.DTRETIRADA <> :NEW.DTRETIRADA) THEN
            V_DESC := V_DESC || ' DataReti de=' || :OLD.DTRETIRADA|| ' para=' || :NEW.DTRETIRADA;
         END IF;
      ELSE
         V_DESC := V_DESC || ' DataReti=' || :NEW.DTRETIRADA;
      END IF;
      IF (NVL(:NEW.NRREQUEXTRRE, '') <> '') OR (UPDATING AND (NVL(:NEW.NRREQUEXTRRE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRREQUEXTRRE, '') <> NVL(:NEW.NRREQUEXTRRE, '')) THEN
               V_DESC := V_DESC || ' RequExt de=' || :OLD.NRREQUEXTRRE || ' para=' || :NEW.NRREQUEXTRRE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' RequExt=' || :NEW.NRREQUEXTRRE;
         END IF;
      END IF;
      IF (NVL(:NEW.CDFILANCESTQ, '') <> '') OR (UPDATING AND (NVL(:NEW.CDFILANCESTQ, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDFILANCESTQ, '') <> NVL(:NEW.CDFILANCESTQ, '')) THEN
               V_DESC := V_DESC || ' FiliEst de=' || :OLD.CDFILANCESTQ || ' para=' || :NEW.CDFILANCESTQ;
            END IF;
         ELSE
            V_DESC := V_DESC || ' FiliEst=' || :NEW.CDFILANCESTQ;
         END IF;
      END IF;
      IF (NVL(:NEW.NRLANCESTQ, '') <> '') OR (UPDATING AND (NVL(:NEW.NRLANCESTQ, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRLANCESTQ, '') <> NVL(:NEW.NRLANCESTQ, '')) THEN
               V_DESC := V_DESC || ' Lanto de=' || :OLD.NRLANCESTQ || ' para=' || :NEW.NRLANCESTQ;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Lanto=' || :NEW.NRLANCESTQ;
         END IF;
      END IF;
      IF (NVL(:NEW.IDRETIPRAT, '') <> '') OR (UPDATING AND (NVL(:NEW.IDRETIPRAT, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDRETIPRAT, '') <> NVL(:NEW.IDRETIPRAT, '')) THEN
               V_DESC := V_DESC || ' RetiPrat de=' || :OLD.IDRETIPRAT || ' para=' || :NEW.IDRETIPRAT;
            END IF;
         ELSE
            V_DESC := V_DESC || ' RetiPrat=' || :NEW.IDRETIPRAT;
         END IF;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('RETIRADA', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/

