var Ctb22000_RazaoOficial_Controller = function(ScreenService, General) {

    this.preparaFiltroRazaoOficial = function(widget, preference){
      
      // Verificando a NRORG para passar o modelo de BIRT para gerar os dados da tabela para atender demanda específia da SAPORE
      var nrorg =  getLocalVar('NRORG');
      var paramProcedureRelesp = 'N';
      
      //NRORG SAPORE 1241
      if(nrorg === 1241){
        paramProcedureRelesp = 'S';
      }
        // Dados do Fitro aplicado na tela
        var filtro = preference.FILTER_ROW;
        
        //Array para armazenar parametros da procedure 
        let paramProcedure = {};
        
        // Itera sobre os dados para passar cada indice ao seu valor
        Object.keys(filtro).forEach((item) => {
            switch(item) {
                case 'CDEMPRESA': 
                  paramProcedure.P_CDEMPRESA = filtro[item];
                  break;
                case 'CDCONTCTBLINI': 
                  paramProcedure.P_CDCONTCTBLINI = filtro[item];
                  break;
                case 'CDCONTCTBLFIN': 
                  paramProcedure.P_CDCONTCTBLFIN = filtro[item];
                  break;
                case 'DTLANCCONT': 
                  paramProcedure.P_DTINICIAL = filtro.DTLANCCONT.start;
                  paramProcedure.P_DTFINAL = filtro.DTLANCCONT.end;
                  break;
              }
          // parametro da procedure que é sempre fixo      
          paramProcedure.P_RELESP = paramProcedureRelesp;
        });
        
        
        
        //Chamada da Procedure para gerar o Razão
        General.callRestEngine("ctb#/executaProcedureRazaoOficial", "Row", paramProcedure).then(function(response) {
            //Após a execução da procedure, preenche o parametros para busca dos dados
            widget.dataSourceFilter = [];
              widget.dataSourceFilter = [
                  {
                    "name": "NRRAZAO",
                    "operator": "=",
                    "value": response.dataset.Razao.P_NRRAZAO
                  },
                  {
                    "name": "DTINICIAL",
                    "operator": "=",
                    "value":  paramProcedure.P_DTINICIAL
                  },    
                  
                  {
                    "name": "DTFINAL",
                    "operator": "=",
                    "value": paramProcedure.P_DTFINAL
                  }
                ];
            widget.reload();
        });
    };
    
    /*
     * Função chamada pela tela ao ser aberta.
     * Seta a máscara de conta contábil buscada da PARAMGERAL na variável.
     */
    this.setContctblMask = function() {
        // Chama a rota que retorna os dados da PARAMGERAL.
        General.callRestEngine("ctb#/crud/paramgeral", "FilterData", []).then(function(response) {
            // Busca o primeiro dado retornado, que será o único registro da parametrização.
            var paramgeral = response.dataset.paramgeral[0];

            // Armazena o valor da máscara na variável.
            contctblMask = paramgeral.CDPICTCCTB;
        });
    };
    
    this.generateReport = function(widget, format) {
      
      var nrorg =  getLocalVar('NRORG');
      var paramRel = {
          'NRRAZAO': widget.dataSourceFilter[0].value,
          'DTINICIAL': widget.dataSourceFilter[1].value,
          'DTFINAL': widget.dataSourceFilter[2].value,
          '__FORMAT': format
      };
      
      if(nrorg === 1241){ // Verifica o NRORG e seta o nome do relatório Birt específico para Sapore
        
        if (format == 'pdf'){
    		    widget.currentRow.NMRELATORIO = "CTB22000_SAPORE";
    		} else {
    		    widget.currentRow.NMRELATORIO = "CTB22000_SAPOREXLSX";
    		}
      } else {
        if (format == 'pdf'){
    		    widget.currentRow.NMRELATORIO = "CTB22000";
    		} else {
    		    widget.currentRow.NMRELATORIO = "CTB22000XLSX";
    		}
      }
		
		General.openReport("ctb#/geraRelatorioRazaoOficial", widget.currentRow.NMRELATORIO,paramRel);
		
	};

};

Configuration(function(ContextRegister){
    ContextRegister.register('Ctb22000_RazaoOficial_Controller', Ctb22000_RazaoOficial_Controller);
});