var Ctb22100_RazaoGerencial_Controller = function(ScreenService, General, templateManager) {

    var contctblMask = "";

    this.setContctblMask = function() {
        General.callRestEngine("ctb#/crud/paramgeral", "FilterData", []).then(function(response) {
            var paramgeral = response.dataset.paramgeral[0];

            contctblMask = paramgeral.CDPICTCCTB;
        });
    };

    this.getContctblMask = function() {
        return contctblMask;
    };

    this.preparaFiltroRazaoGerencial = function(args) {
    	var widget    = templateManager.container.getWidget('RazaoGerencialGrid');
    	var filterRow = args.e.preference.FILTER_ROW;
    	
    	args.e.preference.FILTER_ROW = {};
    	args.e.preference.CUSTOM_FILTER_ROW = {};
    	
    	General.callRestEngine('ctb#/geraRazaoGerencial', 'Row', filterRow).then(function (response) {
    		var nrctbtemp = response.dataset.ctbtemp[0];
    		
    		var filtro = [
    			{
    				"name": "NRCTBTEMP",
    				"operator": "=",
    				"value": nrctbtemp
    			},
    			{
                  "name": "CDOPERADOR",
                  "operator": "=",
                  "value": getLocalVar('CDOPERADOR')
                }
    		];
    		
    		args.e.preference.FILTER_ROW = {"NRCTBTEMP" : nrctbtemp};
    		widget.dataSourceFilter = filtro;
    		widget.reload();
    	}).catch(function(erro){
    		ScreenService.showMessage(erro.data.error);
    	});
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Ctb22100_RazaoGerencial_Controller', Ctb22100_RazaoGerencial_Controller);
});