const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const contadorPage = require('../../../page-objects/parametrizacao/contabil/contador.po.js');
const j = require('../../../json/leitorJson.po.js');
const protractorHelper = require('protractor-helper');

const contadorGridId = '205027091127302631252512';

describe('Tela Contador', () => {
	beforeAll(() => {
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		geral.abrir(['Parametrização', 'Contábil', 'Contador']);
		z.component.footer.clickRightActionByLabel('Filtrar', true);
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${contadorGridId}`)));
	});

	afterAll(() => {
		geral.sair();
	});

	it('Acessar a tela Contador', () => {
		expect(z.component.header.getTitle())
			.toBe('Contador');
	});

	it('Adicionar um contador', () => {
		geral.clickAdicionar();
		contadorPage.adicionar(j.getValor('codigoContador'), j.getValor('nomeContador'), j.getValor('cpf'),
			j.getValor('telefone'), j.getValor('ramal'), j.getValor('emailContador'), j.getValor('cep'),
			j.getValor('estadoEmissaoCRC'), j.getValor('registroCRC'), j.getValor('numeroCRP'),
			j.getValor('anoEmissaoCRP'), j.getValor('dataVencimentoCRP'), j.getValor('estadoEmissaoCRP'));
		geral.clickSalvar();
		geral.waitFieldVisibility('CDCONTADOR2');

		expect(geral.getTextoPorId('CDCONTADOR2'))
			.toBe(j.getValor('codigoContador'));
		expect(geral.getTextoPorId('NMCONTADOR'))
			.toBe(j.getValor('nomeContador'));
		expect(geral.getTextoPorId('NRCRCCONT2'))
			.toBe(j.getValor('registroCRC'));
	});

	it('Editar o resgistro', () => {
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${contadorGridId}`)));
		geral.clickGrid('CDCONTADOR2', j.getValor('codigoContador'), contadorGridId);
		geral.clickEditar();
		contadorPage.editar(j.getValor('nomeContador1'), j.getValor('cpf1'),
			j.getValor('telefone1'), j.getValor('ramal1'), j.getValor('emailContador1'), j.getValor('cep1'),
			j.getValor('estadoEmissaoCRC1'), j.getValor('registroCRC1'), j.getValor('numeroCRP1'),
			j.getValor('anoEmissaoCRP1'), j.getValor('dataVencimentoCRP1'), j.getValor('estadoEmissaoCRP1'));
		geral.clickSalvar();
		geral.clickOk();
		geral.waitFieldVisibility('CDCONTADOR2');

		expect(geral.getTextoPorId('CDCONTADOR2'))
			.toBe(j.getValor('codigoContador'));
		expect(geral.getTextoPorId('NMCONTADOR'))
			.toBe(j.getValor('nomeContador1'));
		expect(geral.getTextoPorId('NRCRCCONT2'))
			.toBe(j.getValor('registroCRC1'));
	});

	it('Excluir o registro', () => {
		geral.clickGrid('CDCONTADOR2', j.getValor('codigoContador'), contadorGridId);
		geral.clickExcluir();
		geral.clickSim();
		geral.waitFieldVisibility('CDCONTADOR2');

		expect(geral.getTextoPorId('CDCONTADOR2'))
			.toBeUndefined();
		expect(geral.getTextoPorId('NMCONTADOR'))
			.toBeUndefined();
		expect(geral.getTextoPorId('NRCRCCONT2'))
			.toBeUndefined();
	});
});
